/*
 * New Services Options. Just put in options that are likely to change here. (-GZ)
 * Added a few comments to help unexperienced users out - Tux
 * Yet more comments (yay) - Tux 
*/

#ifndef __OPTIONS_H
#define __OPTIONS_H

/* Location and path defines */

/* [!] USE THE FULL PATH!! ex: /home/ircd/Sirius1.10-fix/db/ [!] */

#define DATABASEDIR "./db"		 	/* The path to the databases */
#define MYNAME  "./services" 			/* Location of the services executable */
#define CFGPATH "./config"	   			/* The default path for services data */
#define PIDFILE "./services.pid" 		/* Location of the .pid file */
#define COREDIR "." 				/* Here we keep our core-archive */
#define LOGDIR "./logs"
#define COREFILE "core"				/* This is the actual name of your corefile */

/* Debugging and coding related defines */



#undef NOFORK 						/* With this defined services wont fork */
#define FORCE_CORE					/* Force services to spit out a core file */
#undef DEBUG						/* Specify DEBUG-LEVEL (#define DEBUG <level>) */
#undef DBDEBUG						/* Debug database calls */
#undef CDEBUG						/* Channel debug */
#undef HASHDEBUG					/* Hash table debug */
#ifdef DEBUG
	void _debug(int level, char *msg, ...);
	#define Debug(x) _debug x
#else
	#define Debug(x) ;
#endif
#define DEBUG_ERROR     1 				/* Errors are reported */
#define DEBUG_WARN      2				/* Debug warnings */
#define DEBUG_NOTICE    3 				/* Debug notices */
#define DEBUG_INFO      4				/* Debug information */
#define DEBUG_TCP       5 				/* Connection, Sent, Received, etc */
#undef  TELNET						/* Enable telnet port for debugging */
#define ANALYSE_FUNCTIONS				/* Allows advanced command debugging */

/* Operating system related defines */

#define FREEBSD						/* Define if you are using FreeBSD */

/* Network defines */

#define NETWORK "SiriusNet"				/* Define your network name */
#define NETWORKNAME "Sirius"
#define SERVERMLINE "Sirius IRC User Services"		/* Define your server MLINE */
#define AKILLMSG "Akilled User.  E-mail kline@mynet.org for more info." /* self explanitory */	
#define AKILLMAILTO "kline@services.sirius.net"		/* This is where akill mail goes to */
#define CLOSUREADDY "close@services.sirius.net"
#define sversion 1.10					/* Define services version */
#define RELEASE "RELEASE"	 			/* Define release version */
#define BACKUPDATABASE					/* Define if you want to backup databases or not */
#define MAXSQ  500000                                   /* Max amount of bytes allowed in your send queue */
#define MAXRQ  500000                                   /* Max amount of bytes alloed in your receive queue */

/* Do you want to connect to an UnrealIRCd? change #undef to #define if yes */
/* Note: It must be Unreal3.1 or later! No versions before 3.1 are supported! */
 
#undef UNREAL

#endif
