/*
 * Copyright (c) 1999-2000 GZ
 * Copyright (c) 1998 Bill Jones
 * Copyright (c) 1997 Max Byrd
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the authors nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS `AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "services.h"

/*
 * For lack of better place to put this stuff....
 * * MOTD/help stuff, :>
 */

void showMotd(char *to)
{
  FILE           *fp;
  char            data[81];

  sSend(":%s 375 %s :- %s Message of the Day - ", myname, to, myname);

  fp = fopen("config/services.motd", "r");
  if (fp == NULL)
    return;

  while (fgets(data, 81, fp)) {
    sSend(":%s 372 %s :%s", myname, to, data);
  }
  sSend(":%s 372 %s :-", myname, to);
  sSend(":%s 372 %s :- Sirius IRC Network User Services v%.2f-%s.", myname, to, sversion, RELEASE);
  sSend(":%s 372 %s :- Copyright (c) 2000 Maarten van den Bosch.", myname, to);
  sSend(":%s 372 %s :-", myname, to);
  sSend(":%s 372 %s :- Coded by GZ   - gz@ircsystems.net", myname, to);
  sSend(":%s 372 %s :-          Stskeeps - stskeeps@ircsystems.net", myname, to);
  sSend(":%s 372 %s :-", myname, to);
  sSend(":%s 372 %s :- There are currently \002%lu\002 nicknames and \002%lu\002 channels registered.", myname, to, mostnicks, mostchans);
  sSend(":%s 372 %s :- Our current user-record is \002%lu\002 users.", myname, to, mostusers);
  sSend(":%s 372 %s :-", myname, to);
  sSend(":%s 372 %s :End of /MOTD command", myname, to);
  fclose(fp);

}

/* Used for parsing of the helpdata */
char tmpstr[81];

char *parsestr(char *str)  
{
        char *s1, *s2;
        
        s2 = tmpstr;
        bzero(tmpstr,81);
                
        for (s1 = str; *s1; s1++) {  
                if (*s1 == '%')
                        *s2 = '\002';
                else if (*s1 == '&')
                        *s2 = '\x1f';
                else
                        *s2 = *s1;
                s2++;
        }
                
        return (char *) tmpstr;
}

char *fixnullstr(char *str)
{
        char *s1, *s2;
        int allspace = 1; 
        
        for (s1 = str; *s1; s1++) {   
                if (*s1 != ' ') {
                        allspace = 0;
                        break;
                }
        }              
        if (allspace || !*str) {
                strcpy(str," ");
                return str;
        }
        else {
                s2 = parsestr(str);
                return s2;
        }
}    
void sendHelp(char *to, char *service, char *args[511], int numargs)
{
	int             i;
	char            data[81];
	char            filename[512];
	char            searchargs[512];
	FILE           *fp;

	UserList *tmp;
	if (service == NULL)  /* YIPE -- NO SERVICE ASKED FOR THIS */
		return;

	strcpy(filename,service);
	strcat(filename,"/");

  	if (numargs == 0) { /* DEFAULT -- INDEX.HELP */
    		strcat(filename, "index.help\0");
		strcpy(searchargs,service);
	}
	else {
    		strcat(filename, args[1]);
		strcpy(searchargs, args[1]);
		i = 2;
		while (i < numargs) {
      		strcat(filename, "-");
      		strcat(filename, args[i]);
			strcat(searchargs," ");
			strcat(searchargs, args[i]);
      		i++;
		}
		strcat(filename, ".help\0");
	}
	strtolower(filename);

	i = 0;

	if ((fp = fopen(filename, "r")) != NULL) {
	
		tmp = getNickData(to);

		if(tmp) {
			while (sfgets(data, 81, fp)) {
				if (!strncmp(data, "<oper>",6)) {
					while(sfgets(data, 81, fp) && strncmp(data, "</oper>",7)) {
						if(isOper(tmp)) {
							uSend(service, tmp, GetReply(RPL_HELP, tmp), fixnullstr(data));
							i++;
						}
					}
				}
				else if (!strncmp(data, "<servop>",8)) {
					while(sfgets(data, 81, fp) && strncmp(data, "</servop>",9)) {
						if(isServop(tmp)) {
							uSend(service, tmp, GetReply(RPL_HELP, tmp), fixnullstr(data));
							i++;
						}
					}
				}
				else if (!strncmp(data, "<root>",6)) {
					while(sfgets(data, 81, fp) && strncmp(data, "</root>",7)) {
						if(isRoot(tmp)) {
							uSend(service, tmp, GetReply(RPL_HELP, tmp), fixnullstr(data));
							i++;
						}
					}
				}
				else {
					uSend(service, tmp, GetReply(RPL_HELP, tmp), fixnullstr(data));
					i++;
				}
			}
		}
		fclose(fp);
	}

	if (!i) {
		tmp = getNickData(to);
		uSend(service, tmp, GetReply(ERR_NOHELPONTHAT, tmp), searchargs);
	}
}

void WSsendHelp(char *to, char *service, char *args[511], int numargs)
{
     /* This is a modified version of the standard sendHelp,
      * the only difference is, that it uses PRIVMSG instead 
      * of NOTICE.
      *                        - GZ
      */

	int             i;
	char            data[81];
	char            filename[512];
	char            searchargs[512];
	FILE           *fp;

	UserList *tmp;
	if (service == NULL)  /* YIPE -- NO SERVICE ASKED FOR THIS */
		return;

	strcpy(filename,service);
	strcat(filename,"/");

  	if (numargs == 0) { /* DEFAULT -- INDEX.HELP */
    		strcat(filename, "index.help\0");
		strcpy(searchargs,service);
	}
	else {
    		strcat(filename, args[1]);
		strcpy(searchargs, args[1]);
		i = 2;
		while (i < numargs) {
      		strcat(filename, "-");
      		strcat(filename, args[i]);
			strcat(searchargs," ");
			strcat(searchargs, args[i]);
      		i++;
		}
		strcat(filename, ".help\0");
	}
	strtolower(filename);

	i = 0;

	if ((fp = fopen(filename, "r")) != NULL) {
	
		tmp = getNickData(to);

		if(tmp) {
			while (sfgets(data, 81, fp)) {
				if (!strcmp(data, "oper")) {
					while(sfgets(data, 81, fp) && strcmp(data, "/oper")) {
						if(isOper(tmp)) {
					  		sSend(":%s PRIVMSG %s :%s", service, to, fixnullstr(data));
							i++;
						}
					}
				}
				else if (!strcmp(data, "servop")) {
					while(sfgets(data, 81, fp) && strcmp(data, "/servop")) {
						if(isServop(tmp)) {
					  		sSend(":%s PRIVMSG %s :%s", service, to, fixnullstr(data));
							i++;
						}
					}
				}
				else if (!strcmp(data, "root")) {
					while(sfgets(data, 81, fp) && strcmp(data, "/root")) {
						if(isRoot(tmp)) {
					  		sSend(":%s PRIVMSG %s :%s", service, to, fixnullstr(data));
							i++;
						}
					}
				}
				else {
			  		sSend(":%s PRIVMSG %s :%s", service, to, fixnullstr(data));
					i++;
				}
			}
		}
		fclose(fp);
	}

	if (!i)
		sSend(":%s PRIVMSG %s :No help was available on \002%s\002.", service, to, searchargs);
}
