/*
 * Copyright (c) 1999-2000 GZ
 * Copyright (c) 1998 Bill Jones
 * Copyright (c) 1997 Max Byrd
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the authors nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS `AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
                            
#include "services.h"

char            buffer[4096];
int             pdr,pds,brcv,bsnd;
int             bleah = 0;

void            checkTusers(void);
void            readConf(void);

int main()
{
	fd_set          readme;
	FILE           *fp;
	struct timeval tv;
	int i;
	time_t timestart;
	char    backup[124];
	int languages;

#ifdef FORCE_CORE
	struct rlimit   corelim;
#endif
#ifndef DEBUG
	int forked = 0;
#endif

	antiloop = 0;
	timerbuff[0] = '\0';
	debugbuff[0] = '\0';
	
	startup = time(NULL);
	
	/* use some very neato FreeBSD malloc() stuff... */
	setenv("MALLOC_OPTIONS", "AR", 1);
	
	if (chdir(CFGPATH) == -1)
	  fprintf(stderr, "Cannot chdir(%s)\n", CFGPATH);
/*	if(!strcmp(CFGPATH, ".")) {
		printf("Please specify a full pathname for the configuration path\n");
		return 0;
	}
*/
#ifdef FORCE_CORE
	corelim.rlim_cur = corelim.rlim_max = RLIM_INFINITY;
	setrlimit(RLIMIT_CORE, &corelim);
#endif
	
        cslock = open(DATABASEDIR "/chanserv.db", O_RDONLY);
        i=flock(cslock, LOCK_EX|LOCK_NB);
        if(!i)
        nslock = open(DATABASEDIR "/nickserv.db", O_RDONLY);
        i=flock(nslock, LOCK_EX|LOCK_NB);
        if(!i)
        mslock = open(DATABASEDIR "/memoserv.db", O_RDONLY);
        i=flock(mslock, LOCK_EX|LOCK_NB);
        if(i) {
                printf("Unable to lock Database files!\n");
                sshutdown(-1);
        }
        else
		printf("Database files locked\n");

	timestart = time(NULL);
	strftime(backup, 120, COREDIR "/core.%d%b.%H%M", localtime(&timestart));
	if (rename(CFGPATH "/" COREFILE, backup) == 0) {
			  printf("Saving core file '%s' -> '%s'\n", CFGPATH "/" COREFILE, backup);
	} else if (errno == ENOENT) {
			  printf("Services appears to have terminated normally last time it was shutdown.\n");
	} else {
			  printf("Error backing up '%s' to '%s': %s\n", CFGPATH "/" COREFILE, backup, strerror(errno));
	}
	
	firstRegNick = lastRegNick = NULL;
	firstUser = lastUser = NULL;
	firstReg = lastReg = NULL;
	firstChan = lastChan = NULL;
	firstRegChan = lastRegChan = NULL;
#ifdef SERVICESOPER
	firstOper = lastOper = NULL;
#endif
	pdr=pds=0;
	brcv=bsnd=0;
	
	printf("Loading Sirius Services...\n");
	
	/* logging files */
	rootlog = fopen(LOGDIR "/root.log", "a");
	if (rootlog == NULL) {
		printf("Failed to open root log\n");
		return 201;
	}
	operlog = fopen(LOGDIR "/operserv.log", "a");
	if (operlog == NULL) {
		printf("Failed to open operserv log\n");
		return 201;
	}
	nicklog = fopen(LOGDIR "/nickserv.log", "a");
	if (nicklog == NULL) {
		printf("Failed to open nickserv log\n");
		return 201;
	}
	chanlog = fopen(LOGDIR "/chanserv.log", "a");
	if (chanlog == NULL) {
		printf("Failed to open chanserv log\n");
		return 201;
	}
	corelog = fopen(LOGDIR "/core.log", "a");
	if (corelog == NULL) {
		printf("Failed to open core log\n ");
		return 201;
	}
	printf("Logfiles opened\n");
	
	/*
	 * clear out our hash lists 
	 */
	cleanNickHash();
	cleanChanHash();
	printf("Hashes cleaned\n");
	
	AllocCalled = FreeCalled = 0;
	printf("Reading Databases/configuration...\n");
	printf("NickServ..."); readNickData();
	printf("done.\n");
	printf("ChanServ..."); readChanData();
	printf("done.\n");
	printf("MemoServ..."); readConf();
	printf("done.\n");
	printf("Complete...\n");
	printf("My name          : %s\n", myname);
	printf("Primary host/port: %s %i\n", hostname[0], port[0]);
	printf("Op/Akick Limits  : %i/%i\n", OpLimit, AkickLimit);
	printf("Nick/Chan Limits : %i/%i\n", NickLimit, ChanLimit);
	printf("Access Item Limit: %i\n", AccessLimit); 
	
	
	fp = fopen(CFGPATH "/services.totals", "r");
	
	if(fp) {
		sfgets(buffer, 256, fp);
		mostusers = atoi(buffer);
		bleah = mostusers;
		sfgets(buffer, 256, fp);
		mostnicks = atoi(buffer);
		sfgets(buffer, 256, fp);
		mostchans = atoi(buffer);
		sfgets(buffer, 256, fp);
		mostmemos = atoi(buffer);
		fclose(fp);
	}
	printf("Saved Totals: Users: %lu Nicks: %lu Chans: %lu Memos: %lu\n", mostusers, mostnicks, mostchans, mostmemos);
	totalusers = 6;

	signal(SIGPIPE, segvdie);
	signal(SIGSEGV, segvdie);
	signal(SIGHUP, SIG_IGN);
#ifdef DEBUG
	signal(SIGINT, segvdie);
#else
	signal(SIGINT, SIG_IGN);
#endif
	signal(SIGBUS, segvdie);
	signal(SIGTERM, segvdie);

	printf("Added signal handlers\n");
	OperServ = services[0].name;
	NickServ = services[1].name;
	ChanServ = services[2].name;
	MemoServ = services[3].name;
        GlobalMessenger = NETWORKNAME;
        WebServ = services[4].name;

	/* Load the language-tables here */

	languages = LoadTables();

	server = -1;
	for(i=0;i<10 && hostname[i][0];i++) {
		server = ConnectToServer(hostname[i], port[i]);
		if(server >= 1)
		  break;
	}
	
	if (server < 0) {
		printf("Could not connect to server!, exiting now.\n");
		exit(0);
	} 
	else {
		synched = 0;
		servout = fdopen(server, "a");
		sSend("PASS %s", mypass);
#ifndef UNREAL
		sSend("SERVER %s 1 Star5.10.fx4_cap1 :%s", myname, SERVERMLINE);
#else
		sSend("SERVER %s 1 :%s", myname, SERVERMLINE);
#endif
		/* This could be done with SJOIN or SNICK */

		addUser(services[0].name, services[0].uname, services[0].host, services[0].rname, services[0].mode);
		addUser(services[1].name, services[1].uname, services[1].host, services[1].rname, services[1].mode);
		addUser(services[2].name, services[2].uname, services[2].host, services[2].rname, services[2].mode);
		addUser(services[3].name, services[3].uname, services[3].host, services[3].rname, services[3].mode);
                addUser(services[4].name, services[4].uname, services[4].host, services[4].rname, services[4].mode);
                addUser(GlobalMessenger, "services", NETWORK, "Global Messenger", "+on");
                sSend(":%s JOIN #Services", MemoServ);
                sSend(":%s JOIN #Services", ChanServ);
                sSend(":%s JOIN #Services", NickServ);
                sSend(":%s JOIN #Services", WebServ);
                sSend(":%s JOIN #Services", OperServ);
                sSend(":%s JOIN #Services", GlobalMessenger);
		sSend(":%s MODE #Services +oooooo %s %s %s %s %s %s", ChanServ, MemoServ, NickServ, WebServ, OperServ, ChanServ, GlobalMessenger);
                sSend(":%s JOIN %s", WebServ, WEBTVCHAN);
                sSend(":%s MODE %s +o %s", WebServ, WEBTVCHAN, WebServ);
		fflush(servout);
	}

	printf("Connected to server %s/%i\n", hostname[i], port[i]);
#ifdef TELNET
	if((telnetsock=listenOnPort(2000))<0) {
		printf("Cannot bind to port 2000, *whine*\n");
		exit(0);
	}
	fcntl(telnetsock, F_SETFL, O_NONBLOCK);
	initTelnet();
	printf("Created telnet socket on port 2000\n");
#endif
	doTfunc("0");
	doTfunc("1");
	doTfunc("2");
	doTfunc("44");
	doTfunc("5");
#ifdef BACKUPDATABASE
	doTfunc("6");
#endif
	printf("Initialized in %lu seconds\n\n", time(NULL) - startup);
#if !defined(DEBUG) && !defined(NOFORK)
	forked=fork();
	if(forked) {
		printf("Forking to background. PID: %i\n", forked);
                flock(pidlock, LOCK_UN);
		fp = fopen(PIDFILE, "w");
		if (fp == NULL) {
			printf("Warning: Failed to create pid file!");
			return 0;
		}
		fprintf(fp, "%i", forked);
		fclose(fp);
		pidlock = open(PIDFILE, O_RDONLY);
		return 0;
	}
#endif
	sSend(":%s GLOBOPS :Sirius IRC Network Services [version %.2f-%s] are now online.", GlobalMessenger, sversion, RELEASE);
	while (1) {			/* loop forever...supposedly... */
		tv.tv_sec = 0;
		tv.tv_usec = 500;
		FD_ZERO(&readme);
		FD_SET(server, &readme);
		bzero(buffer, 4096);
		fflush(servout);
#ifdef TELNET
		checkTelnet();
#endif

		FromSendQ();		/* And here goes the sendQ */

		if (select(server+1, &readme, NULL, NULL, &tv)) {
			  recv(server, buffer, 4096, 0);

			ToRecvQ(buffer);	/* All data read goes right into the recvQ */
		}

		FromRecvQ();		/* And here it comes out again, looks so stupid without threads :) */

		checktimers();
	}
	return 0; /* we never get here but C bitches anyways */
}

void
flushLogs(void)
{
	fflush(nicklog);
	fflush(chanlog);
	fflush(operlog);
	fflush(rootlog);
	timer(60, doTfunc, "doTfunc", "0");
}

void
doTfunc(char *doot)
{
	switch (doot[0]) {
	 case '0':
		flushLogs();
		return;
	 case '1':
		expireChans();
		return;
	 case '2':
		expireNicks();
		return;
	 case '4':
		sync_cfg(doot);
		return;
	case '5':
		loadakills();
	        loadpermignores();
        	loaddynamicekills();
	        loadPermJinxes();
		loadHostJinxes();
		SynchHJinxes();
		return;
	case '6':
		do_remaining_backup();
		return;
	}
}

void srestart()
{
        FILE           *fp = fopen("config/services.totals", "w");

        if(fp) {
                fprintf(fp, "%lu\n%lu\n%lu\n%lu\n", mostusers, mostnicks, mostchans, mostmemos);
                fflush(fp);
                fclose(fp);
        }

        unlink(PIDFILE);
                saveakills();
                savepermignores();
		saveHostJinxes();
                savePermJinxes();
                savedynamicekills();
                saveChanData(firstRegChan);
                saveNickData(firstRegNick);
                saveMemoData(firstRegNick);

                flock(cslock, LOCK_UN);
                flock(nslock, LOCK_UN);
                flock(mslock, LOCK_UN);
                flock(pidlock, LOCK_UN);
                sSend(":%s SQUIT %s :Services %.2f restarted.", myname, hostservername, sversion);
		FromSendQ();		/* Let's empty our SendQ before splitting */
                fflush(servout);
                fclose(servout);
                close(server);
                (void) execv(MYNAME, NULL);
                exit(0);
}

void sshutdown(int type)
{
	FILE           *fp = fopen("config/services.totals", "w");

	if(fp) {
		fprintf(fp, "%lu\n%lu\n%lu\n%lu\n", mostusers, mostnicks, mostchans, mostmemos);
		fflush(fp);
		fclose(fp);
	}
	
	unlink(PIDFILE);
	if(type != (-1) && antiloop < 2) {
		antiloop = 1;
		saveakills();
		savepermignores();
		saveHostJinxes();
                savePermJinxes();
		savedynamicekills();
		saveChanData(firstRegChan);
		saveNickData(firstRegNick);
		saveMemoData(firstRegNick);
	}
	
	
	if (type == 1) {
		sSend(":%s SQUIT %s :Services %.2f fall down go BOOM!", myname, hostservername, sversion);
		FromSendQ();            /* Let's empty our SendQ before splitting */
		fflush(servout);
		fclose(servout); 
		close(server); 
		fclose(corelog);
		kill(getpid(),3);
		kill(getpid(),9);
		exit(1);
	}
	else {
		if (type != -1) {
			sSend(":%s SQUIT %s :Services %.2f shutdown", myname, hostservername, sversion);
			FromSendQ();            /* Let's empty our SendQ before splitting */
			fflush(servout);
			fclose(servout);
			fclose(corelog);
			close(server);
		}
		exit(0);
	}

}

void WriteCoreLog(void)
{
	char temp[512];
	
    	strftime(temp, 80, "%a %d/%m/%Y %T %Z", localtime(&timertime));
	logDump(corelog, "<-=-=-=-=-=-=-=- [Core Information] -=-=-=-=-=-=-=->");
	if(coreBuffer[0])
		logDump(corelog, "Last parsed command: %s", coreBuffer);
	else
		logDump(corelog, "Last parsed command: No commands parsed.");
	if(timerbuff[0])
		logDump(corelog, "Last used timer    : %s at %s", timerbuff, temp);
	else
		logDump(corelog, "Last used timer    : No timers called.");
}

void
segvdie(int doot)
{
	FILE *fp;	/* File Pointer for the totals. -GZ */

	switch (doot) {
	 case SIGPIPE:
	 case SIGINT:
	 case SIGTERM:
		sshutdown(0);
		break;
	 case SIGSEGV:
	 case SIGBUS:
		if(!antiloop) {
			antiloop++;
			
        		fp = fopen("config/services.totals", "w");

        		if(fp) {
	                	fprintf(fp, "%lu\n%lu\n%lu\n%lu\n", mostusers, mostnicks, mostchans, mostmemos);
	                	fflush(fp);
        		        fclose(fp);
		        }

			sSend(":%s GLOBOPS :\002PANICK!\002 Services has detected a fatal error and will shut itself down.", GlobalMessenger);
			WriteCoreLog();
			sshutdown(1);
		} else {

                        fclose(corelog);
	                close(server);
			kill(getpid(),3);  
	                kill(getpid(),9);
		}
		break;
	 default:
		sSend(":%s GLOBOPS :Received unidentified signal %i, ignoring.", myname, doot);
		break;
	}
	return;
}


void readConf(void)
{
	/*
	 * read services.conf 
	 */
	
	FILE           *fp;
	char            buffer[256];
	char *args[256];
	char realargs[256][128];
	int i,x;
	
	for(i=0;i<256;i++)
	  args[i] = realargs[i];
	
	fp = fopen(CFGPATH "/services.conf", "r");
	if (fp == NULL) {
		printf("Failed to open services.conf!");
	}
	while (sfgets(buffer, 256, fp) != NULL) {
		if (*buffer == '#' || !*buffer) {
		}
		else {
			bzero(args[0], 128);
			bzero(args[1], 128);
			bzero(args[2], 128);
			
			i=breakString(255, buffer, args, " \t");			
			if(!strcasecmp(args[0], "MyName"))
			  strcpy(myname, args[1]);
			else if(!strcasecmp(args[0], "Port"))
			  port[atoi(args[1])] = atoi(args[2]);
			else if(!strcasecmp(args[0], "LinkPass"))
			  strcpy(mypass, args[1]);
			else if (!strcasecmp(args[0], "ConnectHost")) {
				strcpy(hostname[atoi(args[1])], args[2]);
				hostname[atoi(args[1])+1][0] = 0;
			}
			else if (!strcasecmp(args[0], "OSNick"))
			  strcpy(services[0].name, args[1]);
			else if (!strcasecmp(args[0], "OSUserName"))
			  strcpy(services[0].uname, args[1]);
			else if (!strcasecmp(args[0], "OSHostName"))
			  strcpy(services[0].host, args[1]);
			else if (!strcasecmp(args[0], "OSRealName")) {
				x=2;
				strcpy(services[0].rname, args[1]);
				while(x<i) {
					strcat(services[0].rname, " ");
					strcat(services[0].rname, args[x]);
					x++;
				}
			}
			else if (!strcasecmp(args[0], "OSUserMode"))
			  strcpy(services[0].mode, args[1]);
			else if (!strcasecmp(args[0], "NSNick"))
			  strcpy(services[1].name, args[1]);
			else if (!strcasecmp(args[0], "NSUserName"))
			  strcpy(services[1].uname, args[1]);
			else if (!strcasecmp(args[0], "NSHostName"))
			  strcpy(services[1].host, args[1]);
			else if (!strcasecmp(args[0], "NSRealName")) {
				x=2;
				strcpy(services[1].rname, args[1]);
				while(x<i) {
					strcat(services[1].rname, " ");
					strcat(services[1].rname, args[x]);
					x++;
				}
			}
			else if (!strcasecmp(args[0], "NSUserMode"))
			  strcpy(services[1].mode, args[1]);
			else if (!strcasecmp(args[0], "CSNick"))
			  strcpy(services[2].name, args[1]);
			else if (!strcasecmp(args[0], "CSUserName"))
			  strcpy(services[2].uname, args[1]);
			else if (!strcasecmp(args[0], "CSHostName"))
			  strcpy(services[2].host, args[1]);
			else if (!strcasecmp(args[0], "CSRealName")) {
				x=2;
				strcpy(services[2].rname, args[1]);
				while(x<i) {
					strcat(services[2].rname, " ");
					strcat(services[2].rname, args[x]);
					x++;
				}
			}
			else if (!strcasecmp(args[0], "CSUserMode"))
			  strcpy(services[2].mode, args[1]);
			else if (!strcasecmp(args[0], "MSNick"))
			  strcpy(services[3].name, args[1]);
			else if (!strcasecmp(args[0], "MSUserName"))
			  strcpy(services[3].uname, args[1]);
			else if (!strcasecmp(args[0], "MSHostName"))
			  strcpy(services[3].host, args[1]);
			else if (!strcasecmp(args[0], "MSRealName")) {
				x=2;
				strcpy(services[3].rname, args[1]);
				while(x<i) {
					strcat(services[3].rname, " ");
					strcat(services[3].rname, args[x]);
					x++;
				}
			}
			else if (!strcasecmp(args[0], "MSUserMode"))
			  strcpy(services[3].mode, args[1]);
                        else if(!strcasecmp(args[0], "WSNick"))
                          strcpy(services[4].name, args[1]);
                        else if(!strcasecmp(args[0], "WSUserName"))
                          strcpy(services[4].uname, args[1]);
                        else if(!strcasecmp(args[0], "WSHostName"))
                          strcpy(services[4].host, args[1]);
                        else if(!strcasecmp(args[0], "WSRealName")) {
                                x=2;
                                strcpy(services[4].rname, args[1]);
                                while(x<i) {
                                        strcat(services[4].rname, " ");
                                        strcat(services[4].rname, args[x]);
                                        x++;
                                }
                        }
                        else if(!strcasecmp(args[0], "WSUserMode"))
                          strcpy(services[4].mode, args[1]);
			else if (!strcasecmp(args[0], "OpLimit"))
			  OpLimit = atoi(args[1]);
			else if (!strcasecmp(args[0], "BanLimit"))
			  AkickLimit = atoi(args[1]);
			else if (!strcasecmp(args[0], "AccessItemLimit"))
			  AccessLimit = atoi(args[1]);
			else if (!strcasecmp(args[0], "ChanLimit"))
			  ChanLimit = atoi(args[1]);
			else if (!strcasecmp(args[0], "NickLimit"))
			  NickLimit = atoi(args[1]);
			else if (!strcasecmp(args[0], "RootAdmin")) {
				RegNickList       *root;
				root = getRegNickData(args[1]);
				if (root) {
					root->flags |= NHOLD;
					root->flags |= NROOT;
				}
			}
			else if (!strcasecmp(args[0],"NetAdmin")) {
				RegNickList	*root;
				root = getRegNickData(args[1]);
				if (root) {
					root->flags |= NHOLD;
					root->flags |= NNETADM;
				}
			}
			else if (!strcasecmp(args[0], "ForceMask"))
			  addForce(args[1]);
			else if (!strcasecmp(args[0], "BanChannel"))
			  addBanChannel(args[1]);
		}
	}
	fclose(fp);
}

#ifdef DEBUG
/* Don't call this function directly, use the macro Debug
 * as follows:
 * Debug((LOGLEVEL,"Mesg %s",param))
 * Don't forget the (( ))
 */
#ifdef DEBUGFILE
static int debugfd = -1;
#endif

void _debug(int level, char *msg, ...)
{
	va_list vl;
	static char debugbuf[2049];
	int len;

	if (level > DEBUG)
		return;
	
	va_start(vl,msg);
	vsprintf(debugbuf,msg,vl);
	va_end(vl);

	len = strlen(debugbuf);
	if (len == 0)
		return;
	if (debugbuf[len-1] != '\n') {
		debugbuf[len++] = '\n';
		debugbuf[len] = 0;
	}
		
	
#ifdef DEBUGFILE 
	if (debugfd == -1) {
		/* Open the debugging file */
		debugfd = open(DEBUGFILE,O_CREAT | O_WRONLY);
		if (debugfd == -1) {
			fprintf(stderr,"Panic! Can't open debugfile \"%s\"! Aborting!\n",
					DEBUGFILE);
			exit(200);
		}
	}
	write(debugfd,debugbuf,len);
#endif
	fputs(debugbuf,stderr);

	return;
}
#endif /* DEBUG */	
