#define NICKLEN 31
#define USERLEN 11
#define HOSTLEN 60
#define CHANLEN 33
#define MEMOLEN 350
#include <time.h>
#include <stdio.h>

typedef struct naccesslist_struct nAccessList;

struct naccesslist_struct {
  char            mask[71];     /* their mask */
  nAccessList    *next;         /* The next mask. */
  nAccessList    *previous;
};

typedef struct nicklist_struct NickList;

struct nicklist_struct {
  char            nick[NICKLEN];
  char            user[USERLEN];
  char            host[HOSTLEN];
  char            realname[51];
  char            password[16];
  char            password2[12];
  char            url[128];
  char            email[10 + HOSTLEN];
  time_t          timestamp;    /* Signon time (again) (Doubles as last seen) */
  time_t          timereg;      /* when this was registered. */
  int             amasks;       /* number of masks in access list */
  int             caccess;      /* their current access level */
  unsigned int    floodlevel;   /* how much flooding by this client? */
  time_t          lastmsg;      /* the last time we received something from this user */
  unsigned int    flags;        /* nick flags */
  unsigned int    oflags;
  nAccessList    *AccessList;   /* Access list */
};

void main(void);
char           *sfgets(char *, int, FILE *);

void main(void)
{
	int f=0;
	NickList *read;
	nAccessList *accitem, *accprev;
	FILE *ns;
	char tmp[129];
	int lineread = 1;
	int i;
	ns = fopen("nickserv.db", "r");
	if(!ns) {
	  printf("Failed to open nickserv.db\n");
	  return;
	}
	while(sfgets(tmp, 128, ns)) {
		if(tmp[0] != '-') {
			printf("!ERROR! NickServ databases are corrupted (line %i)", lineread);
		}
		read = malloc(sizeof(NickList));
		sfgets(tmp, NICKLEN, ns);
		strcpy(read->nick, tmp);
		sfgets(tmp, USERLEN, ns);
		strcpy(read->user, tmp);
		sfgets(tmp, HOSTLEN, ns);
		strcpy(read->host, tmp);
		sfgets(tmp, 51, ns);
		strcpy(read->realname, tmp);
		sfgets(tmp, 128, ns);
		strcpy(read->url, tmp);
		sfgets(tmp, 16, ns);
		strcpy(read->password, tmp);
		sfgets(tmp, 12, ns);
		strcpy(read->password2, tmp);
		sfgets(tmp, 10 + HOSTLEN, ns);
		strcpy(read->email, tmp);
		sfgets(tmp, 14, ns);
		read->timestamp = (time_t)atol(tmp);
		sfgets(tmp, 14, ns);
		read->timereg = (time_t)atol(tmp);
		sfgets(tmp, 6, ns);
		read->amasks = atoi(tmp);
		sfgets(tmp, 6, ns);
		read->flags = atoi(tmp);
		f++;		
		/* read in the access list */
		accitem = malloc(sizeof(nAccessList));
		accitem->previous = accitem->next = NULL;
		read->AccessList = accitem;
		for(i=1;i<=read->amasks;i++) {
			sfgets(tmp, USERLEN+HOSTLEN+3, ns);
			strcpy(accitem->mask, tmp);
			accprev = accitem;
			accitem = malloc(sizeof(nAccessList));
			accitem->previous = accprev;
			accprev->next = accitem;
			accitem->next = NULL;
		}
		free(accitem);
		if(accprev)
		  accprev->next = NULL;
#ifdef DBDEBUG
		  sSend("GNOTICE :Read nick data (%s)", read->nick);
#endif
		printf("Nick - %s, %d access lists\n", read->nick, read->amasks);
//		addNick(read);
	}
        printf("%d nicks read\n", f);
	fclose(ns);
}
char *
sfgets(char *str, int len, FILE *fp)
{
        if(!fgets(str, len, fp))
          return NULL;
        else {
                if(str[0])
                  str[strlen(str) - 1] = 0;
                return str;
        }
}
