/*
 * Copyright (c) 1999-2000 GZ
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the authors nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS `AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "services.h"

extern void doRegChanMode(RegChanList *);
extern void makeModeLockStr(RegChanList *, char *);
extern int countRegAddy(char *);
extern char *showchanoplevel(int);
extern int isFounder(RegChanList *, UserList *);
extern cAkickList *getChanAkick(RegChanList *chan, char *akick);
extern void createGhostChannel(char *);
extern void deleteGhostChannel(char *);

void WCinfoCmd(UserList *, char **, int);
void WNinfoCmd(UserList *, char **, int);
void WCregisterCmd(UserList *, char **, int);
void WNregisterCmd(UserList *, char **, int);
void WCaccessCmd(UserList *, char **, int);
void WNaccessCmd(UserList *, char **, int);
void WCdropCmd(UserList *, char **, int);
void WNdropCmd(UserList *, char **, int);

void WidentifyCmd(UserList *, char **, int);  
void WopCmd(UserList *, char **, int);
void WdeopCmd(UserList *, char **, int);                 
void WnickCmd(UserList *, char **, int);
void WbanCmd(UserList *, char **, int);
void WunbanCmd(UserList *, char **, int);  
void WkickCmd(UserList *, char **, int);
void WwhoisCmd(UserList *, char **, int);
void WactivateCmd(UserList *, char **, int);
void WaddopCmd(UserList *, char **, int);
void WdelopCmd(UserList *, char **, int);
void WlistopCmd(UserList *, char **, int);
void WchansetCmd(UserList *, char **, int);
void WfounderCmd(UserList *, char **, int);
void WsetCmd(UserList *, char **, int);
void WchanmodeCmd(UserList *, char **, int);
void WaddakCmd(UserList *, char **, int);
void WdelakCmd(UserList *, char **, int);
void WlistakCmd(UserList *, char **, int);
void WmodelockCmd(UserList *, char **, int);
void WrestrictCmd(UserList *, char **, int);
void WtopiclockCmd(UserList *, char **, int);
void WinviteCmd(UserList *, char **, int);
void WmassdeopCmd(UserList *, char **, int);
void WmasskickCmd(UserList *, char **, int);
void WmodeclearCmd(UserList *, char **, int);
void WreleaseCmd(UserList *, char **, int);  
void WghostCmd(UserList *, char **, int);  

void sendToWebServ(UserList *nick, char **args, int numargs) {

	char *from = nick->nick;
        RegNickList *err;

        if(!strcmp(args[0], "\001PING")) {
                  if(numargs<3)
                       uSend(WebServ, nick, GetReply(RPL_PING1, nick), args[1]);
                  else
                       uSend(WebServ, nick, GetReply(RPL_PING2, nick), args[1], args[2]);
                  return;
        }

        if(!strcasecmp(args[0], "HELP") && numargs == 1)
          {
                  WSsendHelp(from, "WebServ", NULL, 0);
                  return;
          }

	else if(!strcasecmp(args[0], "HELP")) {
		WSsendHelp(from, "WebServ", args, numargs);
                return;
        }

        else if(!strcasecmp(args[0], "REGISTER")) {
                WNregisterCmd(nick, args, numargs);
                return;
        }

 /* smart info code, if info is request on a nick that start with #, assume it's a channel */

	else if(!strcasecmp(args[0], "INFO")) {
                if(numargs == 2) {
                      if(index(args[1], '#')) {
                            WCinfoCmd(nick, args, numargs);
                      }
                      else {
                            WNinfoCmd(nick, args, numargs);
                      }
                }
                else { 
		      WNinfoCmd(nick, args, numargs);
                }
        return;
	}

        else if(!strcasecmp(args[0], "ACTIVATE")) {
                WactivateCmd(nick, args, numargs); 
                return;
        }

        else if(!strcasecmp(args[0], "WHOIS")) {
                WwhoisCmd(nick, args, numargs);
                return;
        }                 

        else if(!strcasecmp(args[0], "NICK")) {
                WnickCmd(nick, args, numargs);
                return;
        } 

	else if(!(nick->reg)) {
		sSend(":%s PRIVMSG %s :Your nickname is not activated/registered, you only have access to: INFO and REGISTER.", WebServ, from);
                return;
	}

        err=nick->reg; 
        
        if(!(err->flags2 & NWEBTV)) {
                sSend(":%s PRIVMSG %s :You nick is not yet registered as a WebTV user. Please register first.", WebServ, from); 
                return;
        }

        else if(!strcasecmp(args[0], "KICK")) {
                WkickCmd(nick, args, numargs);
                return;
        }                  

        else if(!strcasecmp(args[0], "REGCHAN")) {
                WCregisterCmd(nick, args, numargs);
                return;
        }      

        else if(!strcasecmp(args[0], "BAN")) {
                WbanCmd(nick, args, numargs);
                return;
        } 

        else if(!strcasecmp(args[0], "UNBAN")) {
                WunbanCmd(nick, args, numargs);
                return;
        }            

        else if(!strcasecmp(args[0], "ID")) {
                WidentifyCmd(nick, args, numargs);
                return;
        }          

        else if(!strcasecmp(args[0], "IDENTIFY")) {
                WidentifyCmd(nick, args, numargs);
                return;
        }          

        else if(!strcasecmp(args[0], "OP")) {
                WopCmd(nick, args, numargs);
                return;
        } 

        else if(!strcasecmp(args[0], "DEOP")) {
                WdeopCmd(nick, args, numargs);
                return;
        }
        
       else if(!strcasecmp(args[0], "CHANOP")) {
		int i = 3;
		if(args[1] && args[2]) {
			if(!strcasecmp(args[2], "add"))
			  strcpy(args[0], "addop");
			else if(!match(args[2], "del*"))
			  strcpy(args[0], "delop");
			else if(!strcasecmp(args[2], "list"))
			  strcpy(args[0], "listop");
			else {
				sSend(":%s PRIVMSG %s: Unknown op command %s.\r:%s PRIVMSG %s:/msg %s HELP for assistance.", WebServ, from, args[2], WebServ, from, WebServ);
				return;
			}
		}
		else {
			sSend(":%s PRIVMSG %s :Please specify a CHANOP command AND channel.\r:%s PRIVMSG %s :/msg %s HELP for assistance", WebServ, from, args[2], WebServ, from, WebServ, from, WebServ);
			return;
		}
		while(i<numargs) {
			strcpy(args[i-1], args[i]);
			i++;
		}
		numargs--;
		sendToWebServ(nick, args, numargs);
		return;
	}

        else if(!strcasecmp(args[0], "ADDOP")) {
       			      WaddopCmd(nick, args, numargs);
       }

       else if(!strcasecmp(args[0], "DELOP")) {
			WdelopCmd(nick, args, numargs);
      }

      else if(!match(args[0], "LISTOP*")) {
			WlistopCmd(nick, args, numargs);
      }

      else if(!match(args[0], "SETCHAN")) {
			WchansetCmd(nick, args, numargs);
      }

      else if(!match(args[0], "SET")) {
			WsetCmd(nick, args, numargs);
      }

      else if(!match(args[0], "CHANMODE")) {
			WchanmodeCmd(nick, args, numargs);
      }
	else if(!strcasecmp(args[0], "AKICK")) {
		int i = 3;
		if(args[1] && args[2]) {
			if(!strcasecmp(args[2], "add"))
			  strcpy(args[0], "addak");
			else if(!match(args[2], "del*"))
			  strcpy(args[0], "delak");
			else if(!strcasecmp(args[2], "list"))
			  strcpy(args[0], "listak");
			else {
				sSend(":%s PRIVMSG %s: Unknown akick command %s.\r:%s PRIVMSG %s:/msg %s HELP for assistance.", WebServ, from, args[2], WebServ, from, WebServ);
				return;
			}
		}
		else {
			sSend(":%s PRIVMSG %s :Please specify a AKICK command.\r:%s PRIVMSG %s :/msg %s HELP for assistance", WebServ, from, args[2], WebServ, from, WebServ, from, WebServ);
			return;
		}
		while(i<numargs) {
			strcpy(args[i-1], args[i]);
			i++;
		}
		numargs--;
		sendToWebServ(nick, args, numargs);
		return;
	} 

        else if(!match(args[0], "ADDAK*")) {
		WaddakCmd(nick, args, numargs);
	}

        else if(!match(args[0], "DELAK*")) {
		WdelakCmd(nick, args, numargs);
	}

        else if(!match(args[0], "LISTAK*")) {
		WlistakCmd(nick, args, numargs);
	}

        else if(!match(args[0], "ACCESSCHAN")) {
		WCaccessCmd(nick, args, numargs);
        }

        else if(!match(args[0], "ACCESS")) {
		WNaccessCmd(nick, args, numargs);
        }

	else if(!match(args[0], "M*LOCK")) {
		WmodelockCmd(nick, args, numargs);
	}
	else if(!strcasecmp(args[0], "RESTRICT")) {
		WrestrictCmd(nick, args, numargs);
	}
	else if(!match(args[0], "T*LOCK")) {
		WtopiclockCmd(nick, args, numargs);
	}

        else if(!match(args[0], "INVITE")) {
		WinviteCmd(nick, args, numargs);
        }

       /* smart drop code, if info is request on a nick that start with #, assume it's a channel */

	else if(!strcasecmp(args[0], "DROP")) {
                if(numargs == 2) {
                      if(index(args[1], '#')) {
                            WCdropCmd(nick, args, numargs);
                      }
                      else {
                            WNdropCmd(nick, args, numargs);
                      }
                }
                else { 
		      WNdropCmd(nick, args, numargs);
                }
        return;
	}

	else if(!strcasecmp(args[0], "M*DEOP")) {
		WmassdeopCmd(nick,args,numargs);
	}
	else if(!strcasecmp(args[0], "M*KICK")) {
		WmasskickCmd(nick,args,numargs);
	}
	else if(!strcasecmp(args[0], "MODECLEAR")) {
		WmodeclearCmd(nick,args,numargs);
	}

	else if(!strcasecmp(args[0], "RELEASE")) {
		WreleaseCmd(nick,args,numargs);
	}

	else if(!strcasecmp(args[0], "GHOST")) {
		WghostCmd(nick,args,numargs);
	}

      return;
}
		
void WNinfoCmd(UserList *tmp, char **args, int numargs) {
	
	char *from = tmp->nick;
	
	RegNickList *err;
	UserList *online = NULL;
	
	if(numargs>1)
	  err=getRegNickData(args[1]);
	else
	  err=tmp->reg;
	if(!err) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1] ? args[1] : tmp->nick);
                sSend(":%s PRIVMSG %s :-", WebServ, from);
		return;
	}
	
	sSend(":%s PRIVMSG %s :Information:", WebServ, from);

	if((online = getNickData(err->nick)))
	    sSend(":%s PRIVMSG %s :%s is online right now, for more information: /msg WebServ whois %s", WebServ , from, err->nick, err->nick);

	if(err->flags & NACTIVE)
	  {
		  struct tm *time;
		  char temp[80];
		  if(err->flags & NBANISH)
			 sSend(":%s PRIVMSG %s :%s is banished (unusable, and permanently registered)", WebServ, from, err->nick);

		   /* NOW EMULATES +X THE SAME AS IRCD */

		  if ((err->flags2 & NSTICKYOP) && (!isOper(tmp)) && (err != tmp->reg))
			sSend(":%s PRIVMSG %s :%s[%s@IRCop." NETWORK "] (%s)", WebServ, from, err->nick, err->user, err->realname);
		  else if ((online) && (online->oflags & NISPLUSX) && (!isOper(tmp)) && (err != tmp->reg))
			sSend(":%s PRIVMSG %s :%s[%s@%s] (%s)", WebServ, from, err->nick, err->user, maskme(err->host), err->realname);
		  else
			sSend(":%s PRIVMSG %s :%s[%s@%s] (%s)", WebServ, from, err->nick, err->user, err->host,  err->realname);

		  if(err->info[0])
			 sSend(":%s PRIVMSG %s :Info: %s", WebServ, from, err->info);
		  time=localtime(&err->timestamp);
		  strftime(temp, 80, "%a %d/%m/%Y %T %Z", time);
		  sSend(":%s PRIVMSG %s :Last seen at:    %s", WebServ, from, temp);
		  time=localtime(&err->timereg);
		  strftime(temp, 80, "%a %d/%m/%Y %T %Z", time);
		  sSend(":%s PRIVMSG %s :Registered on:   %s", WebServ, from, temp);
		  if(err->flags & NEMAIL || isOper(tmp))
			 sSend(":%s PRIVMSG %s :Email: %s", WebServ, from, err->email);
		  if(err->url[0])
			 sSend(":%s PRIVMSG %s :URL: %s", WebServ, from, err->url);
		  if(err->flags & NKILL)
			 sSend(":%s PRIVMSG %s :%s has nick collide enforcement", WebServ, from, err->nick);
		  if(err->flags & NNETADM)
		  	 sSend(":%s PRIVMSG %s :%s is the Network Administrator.", WebServ, from, err->nick);			 
		  else if(err->flags & NROOT)
			 sSend(":%s PRIVMSG %s :%s is a Service Root.", WebServ, from, err->nick);
		  else if(err->flags & NSERVOP)
			 sSend(":%s PRIVMSG %s :%s is a Service Operator.", WebServ, from, err->nick);
#ifdef SERVICESOPER
		  else if(err->flags & NOPER)
			 sSend(":%s PRIVMSG %s :%s is an IRC Operator.", WebServ, from, err->nick);
#endif
		  if ((online) && (online->oflags & NISADMIN))
			 sSend(":%s PRIVMSG %s :%s is an IRC Server Administrator.", WebServ, from, err->nick);
#ifndef SERVICESOPER
		  else if(err->flags2 & NSTICKYOP)
			 sSend(":%s PRIVMSG %s :%s is an IRC Operator.", WebServ, from, err->nick);
#endif
		  if(err->flags & NHOLD)
			 sSend(":%s PRIVMSG %s :%s's nick is held.", WebServ, from, err->nick);

		  if(err->flags & NVACATION)
			 sSend(":%s PRIVMSG %s :%s is on vacation.", WebServ, from, err->nick);

		  if(err->memos) {
			  if(err->memos->flags & MNOMEMO)
				 sSend(":%s PRIVMSG %s :%s is not receiving memos", WebServ, from, err->nick);
			  if(err->memos->flags & MNOFORWARD)
				 sSend(":%s PRIVMSG %s :%s does not accept forwarded memos.", WebServ, from, err->nick);
		  }
		  if(err->flags & NBOT)
			 sSend(":%s PRIVMSG %s :%s is a %s bot", WebServ, from, err->nick, err->flags & NREGBOT ? "registered" : "unregistered");
		  if(err->flags2 & NROLEPLAY)
			 sSend(":%s PRIVMSG %s :%s is a registered roleplayer.", WebServ, from, err->nick);

		  sSend(":%s PRIVMSG %s :End of info on %s", WebServ, from, err->nick);
                  sSend(":%s PRIVMSG %s :-", WebServ, from);    
		  return;
	  }

	else if (err->flags & NREG)
	  {
		  sSend(":%s PRIVMSG %s :%s is not activated, but registered", WebServ, from, err->nick);
		  return;
	  }
       
	else
	  {
		  sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1] ? args[1] : tmp->nick);
                  sSend(":%s PRIVMSG %s :-", WebServ, from);
		  return;
	  }
}

void WCinfoCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	RegChanList *chan;
	char timejunk[80];
	char modestring[20];
	
	if(numargs<2) {
		sSend(":%s PRIVMSG %s :You must specify a channel", WebServ, from);
                sSend(":%s PRIVMSG %s :-", WebServ, from);
		return;
	}
	
	chan = getRegChanData(args[1]);
	
	if(!chan) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1]);
                sSend(":%s PRIVMSG %s :-", WebServ, from);
		return;
	}
	
	sSend(":%s PRIVMSG %s :Information on %s:", WebServ, from, chan->name);
	sSend(":%s PRIVMSG %s :Founder: %s", WebServ, from, chan->founder);
	if(chan->desc[0])
	  sSend(":%s PRIVMSG %s :Desc: %s", WebServ, from, chan->desc);
	if(chan->topic[0])
	  sSend(":%s PRIVMSG %s :Topic: %s (%s)", WebServ, from, chan->topic, chan->tsetby);
	sSend(":%s PRIVMSG %s :Options: %s%s%s%s%s%s%s",
			WebServ, from, 
			chan->flags & CIDENT ? "Ident. " : "",
			chan->flags & CPROTOP ? "Protected Ops. " : "",
			chan->flags & CKTOPIC ? "Preserve Topic. " : "",
			chan->flags & COPGUARD ? "Op Guard. " : "",
			chan->flags & CQUIET ? "Quiet Changes. " : "",
			chan->flags & CCLASSIC ? "No AutoOping." : "",
			chan->flags & CNOTICE ? "Join Notice." : "");
	
	makeModeLockStr(chan, modestring);
	if(modestring[0] == 0)
	  strcpy(modestring, "(none)");
	sSend(":%s PRIVMSG %s :Mode Locked to: %s", WebServ, from, modestring);
	sSend(":%s PRIVMSG %s :Topic Lock: Level %i+     Restrict Lock: Level %i+", WebServ, from, chan->tlocklevel, chan->restrictlevel);
	strftime(timejunk, 80, "%a %d/%m/%Y %T", gmtime(&chan->timereg));
	sSend(":%s PRIVMSG %s :Channel registered at: %s GMT", WebServ, from, timejunk);
	strftime(timejunk, 80, "%a %d/%m/%Y %T", gmtime(&chan->timestamp));
	sSend(":%s PRIVMSG %s :Channel last used:     %s GMT", WebServ, from, timejunk);
	sSend(":%s PRIVMSG %s :End of information on %s", WebServ, from, chan->name);
        sSend(":%s PRIVMSG %s :-", WebServ, from);
}

void WNregisterCmd(UserList *tmp, char **args, int numargs) {
	
	char *from = tmp->nick;
	time_t doot = time(NULL);
        char sendfrom[80];
	int err;

	srandom(time(NULL));
	
	if(tmp->reg) {
		if (!tmp->reg->flags&NACTIVE) {
			sSend(":%s PRIVMSG %s :Your nickname is already registered to activate it, \002/msg %s HELP ACTIVATE\002.", WebServ, from, WebServ);
                        sSend(":%s PRIVMSG %s :-", WebServ, from);
                }  
		else {
			sSend(":%s PRIVMSG %s :Your nickname is already registered.", WebServ, from);
                        sSend(":%s PRIVMSG %s :-", WebServ, from);  
		}
                return;
	}
	
	if ((!strncasecmp(from,"Guest",5)) || (!strcasecmp(from,"done"))) {
		sSend(":%s PRIVMSG %s :This nickname cannot be registered.  Please choose another.",WebServ, from);
                sSend(":%s PRIVMSG %s :-", WebServ, from);  
		return;
	}

	if(numargs<3) {
		sSend(":%s PRIVMSG %s :You must specify an e-mail address and a password to register", WebServ, from);
                sSend(":%s PRIVMSG %s :-", WebServ, from);  
		return;
	}
        if((!strchr(args[1], '@')) || (strlen(args[1])<5) || (strlen(args[1])>EMAILLEN)) {
		sSend(":%s PRIVMSG %s :Please specify a valid e-mail address in the form of user@host", WebServ, from);
                sSend(":%s PRIVMSG %s :-", WebServ, from);  
		return;
	}

          if(match(args[1], "*webtv.net*")) {
               sSend(":%s PRIVMSG %s :Sorry, this service is for WebTV users only", WebServ, from);
               sSend(":%s PRIVMSG %s :-", WebServ, from);
               return;
        }
	
	if((15<strlen(args[2])) || (4>strlen(args[2]))) {
		sSend(":%s PRIVMSG %s :Please specify a password that is between 4 to 15 characters long.", WebServ, from);
                sSend(":%s PRIVMSG %s :-", WebServ, from);  
		return;
	}

	if (countRegAddy(args[1]) >= NickLimit) {
		sSend(":%s PRIVMSG %s :You have too many nicks registered.", WebServ, from);
                sSend(":%s PRIVMSG %s :-", WebServ, from);  
		sSend(":%s GLOBOPS :%s (%s) is trying to register too many nicks.", WebServ, from, args[1]);
		return;
	}
	
	tmp->reg = smalloc(sizeof(RegNickList));
	bzero(tmp->reg, sizeof(RegNickList));
	strcpy(tmp->reg->nick, tmp->nick);
	strcpy(tmp->reg->user, tmp->user);
	strcpy(tmp->reg->host, tmp->host);
	sprintf(tmp->reg->password2, "%lu", (long) random());
	tmp->reg->timestamp = CTime;
	tmp->reg->timereg = CTime;
	tmp->reg->lastpwchange = CTime;
	tmp->reg->flags |= NREG;
        tmp->reg->flags2 |= NWEBTV;
	tmp->caccess = 3;
	strcpy(tmp->reg->email, args[1]);
	strncpy(tmp->reg->password, args[2], 15);
	sprintf(sendfrom, "Nickname Services <%s@%s>", WebServ, NETWORK);
	err=sendMail(args[1], sendfrom, "Nickname activation key", 
         "\nYour nickname registration has been verified\n"
         "To activate your nickname: switch to the nickname %s and\n"
         "/msg %s ACTIVATE %s\n"
         "%s is your activation key.  %s is your password.\n"
         "Even when your  nickname is registered, Do not lose this PLEASE.\n\n" 
	   "For additional help, try these commands:\n"
         "     /msg %s HELP\n"
         "\nNOTICE: This mail sent by: %s@%s at %s", 
         tmp->nick, WebServ, tmp->reg->password2, tmp->reg->password2, 
         tmp->reg->password, WebServ,
	   tmp->user, tmp->host, ctime(&(doot)));
	if(!err) {
		sSend(":%s PRIVMSG %s :Registration key sent to %s", WebServ, from, args[1]);
                sSend(":%s PRIVMSG %s :-", WebServ, from);  
		logDump(nicklog, "%s!%s@%s: ACTIVATION key sent to '%s'\n", from, tmp->user, tmp->host, args[1]);
		addRegNick(tmp->reg);
	}
	else {
		sSend(":%s PRIVMSG %s :Mail could not be sent due to %s address error", WebServ, from, err == -2 ? "sender" : "recipient");
                sSend(":%s PRIVMSG %s :-", WebServ, from);  
		sfree(tmp->reg);
		tmp->reg = NULL;
	}
	return;
}

void WactivateCmd(UserList *tmp, char **args, int numargs) {

	char *from = tmp->nick;
	time_t doot;
	
	if(numargs<2)
	{
		sSend(":%s PRIVMSG %s :A validation password is required with %s ACTIVATE", WebServ, tmp->nick, WebServ);
                sSend(":%s PRIVMSG %s :-", WebServ, from);  
		return;
	}
	if(!tmp->reg) {
		sSend(":%s PRIVMSG %s :Your nick is not registered", WebServ, from);
                sSend(":%s PRIVMSG %s :-", WebServ, from);  
		return;
	}
	if(strcmp(args[1], tmp->reg->password2)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
                sSend(":%s PRIVMSG %s :-", WebServ, from);  
		return;
	}
	if(!(tmp->reg->flags & NACTIVE))
	{	     
		char user2[USERLEN], host2[HOSTLEN];
		  
		strcpy(user2, tmp->user);
		strcpy(host2, tmp->host);
		  
		doot = time(NULL);
		  
		if(!(tmp->reg->flags & NDEACC))
		{
			mostnicks++;
			strcpy(tmp->reg->nick, tmp->nick);
			tmp->reg->timereg = time(NULL);
			tmp->reg->firstAcc = smalloc(sizeof(nAccessList));
			mask(user2, host2, 0, tmp->reg->firstAcc->mask);
			tmp->reg->firstAcc->index = 1;
			tmp->reg->firstAcc->next = tmp->reg->firstAcc->previous = NULL;
			tmp->reg->lastAcc = tmp->reg->firstAcc;
			tmp->reg->amasks = 1;
			tmp->caccess = 3;
			tmp->reg->flags |= NACTIVE;
			tmp->reg->url[0] = 0;
			tmp->reg->chans = 0;
			strcpy(tmp->reg->user, tmp->user);
			strcpy(tmp->reg->host, tmp->host);
			strcpy(tmp->reg->realname, tmp->realname);
				 
			sSend(":%s PRIVMSG %s :Your nick %s is now registered", WebServ, from, from);
			sSend(":%s PRIVMSG %s :Your access mask is %s, should you need another,", WebServ, from, tmp->reg->firstAcc->mask);
			sSend(":%s PRIVMSG %s :/msg %s \002ADDMASK\002", WebServ, from, WebServ);
			sSend(":%s PRIVMSG %s :Your registration time is: %s", WebServ, from, ctime(&(doot)));
			if (!tmp->reg->memos) {
				tmp->reg->memos = smalloc(sizeof(MemoBox));
				initMemoBox(tmp->reg->memos);
				sSend(":%s PRIVMSG %s :Your MemoServ memo box has been configured as necessary.", WebServ, from);
			}
			sSend(":%s PRIVMSG %s :And your password is \002%s\002 DO NOT FORGET THIS", WebServ, from, tmp->reg->password);
			sSend(":%s PRIVMSG %s :We are \002NOT\002 responsible for lost passwords!", WebServ, from);
                        sSend(":%s PRIVMSG %s :-", WebServ, from);  
			logDump(nicklog, "%s!%s@%s: REGISTER\n", from, tmp->user, tmp->host);
		}
		else {
			sSend(":%s PRIVMSG %s :Your nick has been re-activated", WebServ, from);
                        sSend(":%s PRIVMSG %s :-", WebServ, from);  
			tmp->reg->flags |= NACTIVE;
			tmp->reg->flags &= ~NDEACC;
		}
	}
	else {
		sSend(":%s PRIVMSG %s :Your nick is already activated", WebServ, from);
                sSend(":%s PRIVMSG %s :-", WebServ, from);
	}
}

void WCregisterCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	cNickList *tmp;
	cAccessList *founder;
	ChanList *chan;
	RegChanList *reg;
	int i;

	if(numargs<2) {
		sSend(":%s PRIVMSG %s :You must specify a channel name to register it", WebServ, from);
		return;
	}
	
	/* ADDED THIS CHECK TO MAKE SURE NICK IS REALLY ACTIVE */
	if (!(nick->reg) || !(nick->reg->flags & NACTIVE)) {
		sSend(":%s PRIVMSG %s :Your nick must be registered in order to register channels.", WebServ,
from);
		return;
	}

	if(!(nick->caccess > 2)) {
		sSend(":%s PRIVMSG %s :You must be identified to register a channel", WebServ, from);
		return;
	}

	chan=getChanData(args[1]);
	tmp=getChanUserData(chan, nick);

	if(!chan || !tmp || !tmp->op) {
		sSend(":%s PRIVMSG %s :You must be both inside, and oped, in the channel you wish to register", WebServ, from);
		return;
	}

	reg = getRegChanData(args[1]);

	if(reg) {
		sSend(":%s PRVIMSG %s :%s is already registered", WebServ, from, reg->name);
		return;
	}

	/* PROPER FIX - THIS VERIFIES ACTUAL CHANNELS REGISTERED TO NICK */

	nick->reg->chans = countRegChans(from);

	if((nick->reg->chans >= ChanLimit && !isServop(nick)) && (!isOper(nick))) {
		sSend(":%s PRIVMSG %s :You have registered too many channels", WebServ, from);
		sSend(":%s GLOBOPS :%s is trying to register too many channels", WebServ, from);
		return;
	}

	nick->reg->chans++;
	reg = smalloc(sizeof(RegChanList));
	initRegChanData(reg);
	chan->reg = reg;
	strcpy(reg->name, chan->name);
	strcpy(reg->founder, nick->reg->nick);
	for(i=0;i<8;i++)
		reg->password[i] = (((u_short)rand())%26)+97;
	reg->timereg = CTime;
	reg->timestamp = CTime;
	sendToChanOps(chan, "%s just registered %s", from, reg->name);
	sSend(":%s PRIVMSG %s :%s is now registered under your nick: \002%s\002", WebServ, from, args[1], from);
	sSend(":%s PRIVMSG %s :You now have FOUNDER (15) access.", WebServ, from);
/*	sSend(":%s PRIVMSG %s :Your password is \002%s\002 DO NOT FORGET IT", WebServ, from, chan->reg->password);
	sSend(":%s PRIVMSG %s :We are NOT responsible for lost passwords.", WebServ, from); */
	sSend(":%s PRIVMSG %s :Your channel is modelocked +tn-k", WebServ, from);
	sSend(":%s PRIVMSG %s :And topic preservation is set on", WebServ, from);
	sSend(":%s PRIVMSG %s :For information on channel maintenance, /msg %s HELP", WebServ, from, WebServ);
	if(isForced(reg->name)) {
		sSend(":%s MODE %s +s", WebServ, reg->name);
		sSend(":%s PRIVMSG %s :This channel is auto set to mode +s as a precaution for our younger users. This will not affect the channel in any way, other than to make it invisible on a channel list.", WebServ, from);
		reg->flags|=CPRIVATE;
		sSend(":%s GLOBOPS :%s registered %s (forced +s)", WebServ, from, reg->name);
	}
	else
		sSend(":%s GLOBOPS :%s registered %s", WebServ, from, reg->name);

	founder = smalloc(sizeof(cAccessList));
	strcpy(founder->nick, nick->reg->nick);
	founder->uflags = FOUNDER;
	
	addChanOp(reg, founder);
	reg->flags |= CKTOPIC;
	reg->mlock |= PM_N;
	reg->mlock |= PM_T;
	reg->mlock |= MM_K;
	addRegChan(reg);
	mostchans++;
	logDump(chanlog, "%s!%s@%s REGISTER (%s)", nick->nick, nick->user, nick->host, reg->name);
}

void WwhoisCmd(UserList *tmp, char **args, int numargs) {

        char* from = tmp->nick;  
        UserList *err;

        if(numargs < 2) {
                 sSend(":%s PRIVMSG %s :You will need to supply a nickname for this command.",WebServ, from);
                 return;
        }

        if (!(err=getNickData(args[1]))) {
                 sSend(":%s PRIVMSG %s :%s no such nick.",WebServ, from, args[1]);
                 return;
        }

        if (isOper(err)) {
               sSend(":%s PRIVMSG %s :%s is %s!%s@IRCop." NETWORK " (%s)", WebServ, from, err->nick, err->nick, err->user, err->realname); 
               return;
        }
        else {
               sSend(":%s PRIVMSG %s :%s is %s!%s@%s (%s)",WebServ, from, err->nick, err->nick, err->user, maskme(err->host), err->realname);
               return;
        }
}						  
void WkickCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	int a;
	RegChanList *tmp;
	ChanList *chan;
	cNickList *tmpnick;

        char reason[1024];
        int i;

	if(numargs<3) {
		sSend(":%s PRIVMSG %s :You must specify a channel and a nickname.", WebServ, from);
		return;
	}


	reason[0] = '\0';

        if(numargs > 3) { 
            for(i=3;i < numargs;i++) {
                strcat(reason, args[i]);
                strcat(reason, " ");
            }                      
        }

	if(strlen(reason) > 200) {
		sSend(":%s PRIVMSG %s :Reason too long.", WebServ, from);
		return;
	}
 
	tmp = getRegChanData(args[1]);
	chan = getChanData(args[1]);

	if(!chan) {
		sSend(":%s PRIVMSG %s :No such channel.", WebServ, from);
		return;
	}
	if(!tmp) {
		sSend(":%s PRIVMSG %s :%s is not registered.", WebServ, from, args[1]);
		return;
	}

        if((tmp->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	if(numargs > 2)
		tmpnick = getChanUserData(chan, getNickData(args[2]));
	else
		tmpnick = getChanUserData(chan, nick);
	
	if(!tmpnick) {
		sSend(":%s PRIVMSG %s :%s is not in %s", WebServ, from, args[2], args[1]);
		return;
	}
	
	a = getChanOp(tmp, from);
	
	if(!a || !getChanOp(tmp, from)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	
	if(a < AOP) {
                sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	else {
            if(numargs < 4) {
		    sSend(":%s KICK %s %s :Kicked by %s", WebServ, args[1], args[2], from);
            }
            else {
                sSend(":%s KICK %s %s :%s", WebServ, args[1], args[2], reason);
            }
		return;
	}
}

void WbanCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	int a;
	RegChanList *tmp;
	ChanList *chan;
	
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :You must specify a channel and a mask.", WebServ, from);
		return;
	}
	
	tmp = getRegChanData(args[1]);
	chan = getChanData(args[1]);

	if(!chan) {
		sSend(":%s PRIVMSG %s :No such channel.", WebServ, from);
		return;
	}
	if(!tmp) {
		sSend(":%s PRIVMSG %s :%s is not registered.", WebServ, from, args[1]);
		return;
	}

        if((tmp->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	a = getChanOp(tmp, from);
	
	if(!a || !getChanOp(tmp, from)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	if(a < AOP) {
                sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	else {
                sSend(":%s PRIVMSG %s :%s banned %s from %s", WebServ, args[1], from, args[2], args[1]);
		sSend(":%s MODE %s +b %s", WebServ, args[1], args[2]);
		return;
	}
}

void WnickCmd(UserList *nick, char **args, int numargs)
{
      char 	*from = nick->nick;
      UserList 	*err;
      int 	find = 0;
      char 	*s = NULL;

	if(numargs<2) {
		sSend(":%s PRIVMSG %s :You must specify a nickname.", WebServ, from);
		return;
	}
	
      if ((err=getNickData(args[1]))) {
              sSend(":%s PRIVMSG %s :The nickname %s is already in use.",WebServ, from, args[1]);
              return;
      }

      /* Here's a new additional check to scan for non-allowed ASCII chars */

      s = args[1];

      while(*s) {
		if(*s < 48 || *s > 125) {
			find = 1;
			break;
		}
		else if(*s > 57 && *s < 65) {
			find = 1;
			break;
		}
		s++;
      } 

      if(find) {
           sSend(":%s PRIVMSG %s :Illegal characters, please try another nickname.", WebServ, from);
           return;
      }

      // It seems like the code below has some redundant args[1] all over it. -GZ

      /* Of course this is being abused, so lets filter -GZ */

      if (!match(args[1], "*s3rv*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from);
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }

      else if (!match(args[1], "*serv*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]); 
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      } 

      else if (!match(args[1], "God")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);     
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }

      else if (!match(args[1], "*cock*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);     
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }       

      else if (!match(args[1], "ircop")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);     
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }       

      else if (!match(args[1], "*oper*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);     
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }       

      else if (!match(args[1], "*cunt*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);     
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }       
      else if (!match(args[1], "*dick*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);     
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }       

      else if (!match(args[1], "*cock*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);     
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }       

      else if (!match(args[1], "*suck*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);     
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }       

      else if (!match(args[1], "*penis*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }

      else if (!match(args[1], "*slut*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }  
        
      else if (!match(args[1], "*pussy*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }
        
      else if (!match(args[1], "*fuck*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      } 

      else if (!match(args[1], "*hitler*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }  

      else if (!match(args[1], "*ass*")) {
           sSend(":%s PRIVMSG %s :Please try another nickname.", WebServ, from, args[1]);
           sSend(":%s GLOBOPS :%s is trying to use the nickname: %s.", WebServ, from, args[1]);
           return;
      }  

      sSend(":%s PRIVMSG %s :Your nick is now %s", WebServ, from, args[1]);
      sSend(":%s SVSNICK %s %s %lu", myname, from, args[1], CTime);

      return;
}

void WunbanCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	int a;
	RegChanList *tmp;
	ChanList *chan;
	
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :You must specify a channel and a mask.", WebServ, from);
		return;
	}
	
	tmp = getRegChanData(args[1]);
	chan = getChanData(args[1]);

	if(!chan) {
		sSend(":%s PRIVMSG %s :No such channel.", WebServ, from);
		return;
	}
	if(!tmp) {
		sSend(":%s PRIVMSG %s :%s is not registered.", WebServ, from, args[1]);
		return;
	}

        if((tmp->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	a = getChanOp(tmp, from);
	
	if(!a || !getChanOp(tmp, from)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	if(a < AOP) {
                sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	else {
                sSend(":%s PRIVMSG %s :%s unbanned %s from %s", WebServ, args[1], from, args[2], args[1]);
		sSend(":%s MODE %s -b %s", WebServ, args[1], args[2]);
		return;
	}
}

void WopCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	int a;
	RegChanList *tmp;
	ChanList *chan;
	cNickList *tmpnick;
	
	if(numargs<2) {
 		sSend(":%s PRIVMSG %s :You must specify a channel", WebServ, from);
		return;
	}
	
	tmp = getRegChanData(args[1]);
	chan = getChanData(args[1]);

	if(!chan) {
		sSend(":%s PRIVMSG %s :No such channel.", WebServ, from);
		return;
	}
	if(!tmp) {
		sSend(":%s PRIVMSG %s :%s is not registered.", WebServ, from, args[1]);
		return;
	}

        if((tmp->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	if(numargs > 2)
		tmpnick = getChanUserData(chan, getNickData(args[2]));
	else
		tmpnick = getChanUserData(chan, nick);
	
	if(!tmpnick) {
		sSend(":%s PRIVMSG %s :%s is not in %s", WebServ, from, (numargs == 3) ? args[2] : from, args[1]);
		return;
	}
	
	a = getChanOp(tmp, (numargs > 2) ? args[2] : from);
	
	if(!a || !getChanOp(tmp, from)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	
	sendToChanOps(getChanData(tmp->name), "%s used \002OP\002 on %s", from, (numargs > 2) ? args[2] : from);
	if(a < AOP) {
		sSend(":%s MODE %s +v %s", WebServ, args[1], (numargs > 2) ? args[2] : from);
		tmpnick->op |= CHANVOICE;
		return;
	}
	else {
		sSend(":%s MODE %s +o %s", WebServ, args[1], (numargs > 2) ? args[2] : from);
                if (numargs > 2) {
                    sSend(":%s PRIVMSG %s :%s is now a channel operator in %s", WebServ, from, args[2], args[1]);
                }
		tmpnick->op |= CHANOP;
		return;
	}
}

void WdeopCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	int a;
	RegChanList *tmp;
	ChanList *chan;
	cNickList *tmpnick;
	
	if(numargs<2) {
		sSend(":%s PRIVMSG %s :You must specify a channel", WebServ, from);
		return;
	}
	
	tmp = getRegChanData(args[1]);
	chan = getChanData(args[1]);

	if(!chan) {
		sSend(":%s PRIVMSG %s :No such channel.", WebServ, from);
		return;
	}
	if(!tmp) {
		sSend(":%s PRIVMSG %s :%s is not registered.", WebServ, from, args[1]);
		return;
	}

        if((tmp->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	if(numargs > 2)
		tmpnick = getChanUserData(chan, getNickData(args[2]));
	else
		tmpnick = getChanUserData(chan, nick);
	
	if(!tmpnick) {
		sSend(":%s PRIVMSG %s :%s is not in %s", WebServ, from, (numargs == 3) ? args[2] : from, args[1]);
		return;
	}
	
	a = getChanOp(tmp, (numargs > 2) ? args[2] : from);
	
	if(!a || !getChanOp(tmp, from)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	sendToChanOps(getChanData(tmp->name), "%s used \002DEOP\002 on %s", from, (numargs > 2) ? args[2] : from);
	sSend(":%s MODE %s -ov %s %s", WebServ, args[1], (numargs == 3) ? args[2] : from, (numargs > 2) ? args[2] : from);
        if (numargs > 2) {
            sSend(":%s PRIVMSG %s :%s is no longer a channel operator in %s", WebServ, from, args[2], args[1]);
        }       
	tmpnick->op &= ~CHANOP;
	return;
}

void WidentifyCmd(UserList *tmp, char **args, int numargs) {
	
	char *from = tmp->nick;

	int old_access;

	if(numargs<2)
	{
		sSend(ERROR_BADUSE_WEBTV, WebServ, from);
		return;
	}
	
	old_access = tmp->caccess;

	if(!strncmp(args[1], tmp->reg->password, 15))
	{
		tmp->caccess = 3;
		tmp->failid = 0; /* o O. it's the real person here better start all over. */
		sSend(":%s PRIVMSG %s :Password accepted, your access is now 3 (Identified)", WebServ, from);
		strcpy(tmp->reg->nick, tmp->nick);
		strcpy(tmp->reg->user, tmp->user);
		strcpy(tmp->reg->host, tmp->host);
		strcpy(tmp->reg->realname, tmp->realname);
		tmp->reg->timestamp = CTime;

		/* ADDED THIS FOR THE NEW ROLEPLAY FLAG */
		if (tmp->reg->flags2&NROLEPLAY)
			sSend(":%s SVSMODE %s +r 0",myname,from);

                /* THIS IS FOR THE SERVICES ROOT AND NETADMIN MASKS (+n/+N) */
                if(tmp->reg->flags & NROOT)
                        sSend(":%s SVSMODE %s +n 0",myname,from); /* Services Root */

                if (tmp->reg->flags & NNETADM)
                        sSend(":%s SVSMODE %s +N 0",myname,from); /* Network Administrator */                         
      
		/* GIVE WARNING IF PASSWORD NOT CHANGED */
		if ((CTime - (tmp->reg->lastpwchange)) > PASSWARNTIME) {
			if (!(tmp->reg->flags2&NNOPWWARN)) {
				sSend(":%s PRIVMSG %s :You have not changed your password recently.", WebServ, from);
				sSend(":%s PRIVMSG %s :\002/msg %s HELP SET PASSWD\002 for more info.", WebServ, from, WebServ);
			}
		}

		checkMemos(tmp);

		if (old_access < 2) {
			if (tmp->reg->flags&NBOT)
				delClone(tmp->user,tmp->host);
		}		
		return;
	}
	else
	{
		/* ADDED THIS FOR ROLEPLAYERS */
		if (tmp->caccess > 1) {
			if (tmp->reg->flags2&NROLEPLAY)
				sSend(":%s SVSMODE %s -r 0",myname,from);

			/* HANDLE SERVICES ROOT/NETADMIN FLAG LOSS */
			if (tmp->reg->flags & NROOT) 
				sSend(":%s SVSMODE %s -n 0",myname,from);
			if (tmp->reg->flags & NNETADM) 
				sSend(":%s SVSMODE %s -N 0",myname,from);
		}

		tmp->caccess = 1;      /* failed identify takes away even the access list ID */
            sSend(":%s PRIVMSG %s :Password incorrect, your access is now 1 (Not identified)", WebServ, from);

		tmp->failid++; /* If you fail id, add one to it */
		if (tmp->failid >= 5)  /* WHOOPSIE, POSSIBLE HACK ATTEMPT! */
			sSend(":%s GLOBOPS :%s!%s@%s has entered an incorrect password too many times.", WebServ, from, tmp->user, tmp->host);
		if (old_access > 1) {
			if (tmp->reg->flags&NBOT)
				addClone(tmp->nick,tmp->user,tmp->host);
		}

	  }
}

void WaddopCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	cAccessList *newitem;
	RegChanList *chan;
	RegNickList *add;
	int access_level;
	int host_access_level;
	
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :You must specify both a channel to add to, and a nick for ADDOP", WebServ, from);
		return;
	}
	
	chan = getRegChanData(args[1]);
	if(!chan) {
		sSend(":%s PRIVMSG %s :%s channel is not registered", WebServ, args[1], from);
		return;
	}

        if((chan->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	host_access_level = getChanOp(chan,from);

	if((SOP > host_access_level) && (!isRoot(nick))) {
		sSend(":%s PRIVMSG %s :Your access is too low to add ops", WebServ, from);
		return;
	}
	
	if(chan->ops >= OpLimit) {
		sSend(":%s PRIVMSG %s :%s has too many ops", WebServ, from, chan->name);
		return;
	}

	newitem = getChanOpData(chan, args[2]);
	if(newitem) {
		sSend(":%s PRIVMSG %s :%s is already in the ops list", WebServ, from, args[2]);
		return;
	}

	access_level = OPNONE;

	if (numargs < 4)
		access_level = AOP;
	else
	{
		if (isalpha(args[3][0]))
		{
			if (!strcasecmp(args[3],"founder"))
				access_level = FOUNDER;
			else if (!strcasecmp(args[3],"cofounder"))
				access_level = MFOUNDER;
			else if (!strcasecmp(args[3],"sop"))
				access_level = SOP;
			else if (!strcasecmp(args[3],"msop"))
				access_level = MSOP;
			else if (!strcasecmp(args[3],"aop"))
				access_level = AOP;
			else if (!strcasecmp(args[3],"voice"))
				access_level = MAOP;
		} else
                        access_level = atoi(args[3]);
	}

	if ((MAOP > access_level) || (FOUNDER < access_level))
	{
		sSend(":%s PRIVMSG %s: The level you specified (%s) is not a valid level", WebServ, from, args[4]);
		return;
	}	

	if(((access_level >= MFOUNDER && FOUNDER > host_access_level) || (access_level >= MSOP && MFOUNDER > host_access_level) || host_access_level < SOP) && (!isRoot(nick)))
	{
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}

	add = getRegNickData(args[2]);
	if(!add || !(add->flags & NACTIVE)) 
	{
		sSend(":%s PRIVMSG %s :The nickname %s is not registered, nicknames must be registered to add as ops", WebServ, from, args[2]);
		sfree(newitem);
		return;
	}

	newitem = smalloc(sizeof(cAccessList));

	newitem->uflags = access_level;
	strcpy(newitem->nick, add->nick);

	sSend(":%s PRIVMSG %s :Added op(%i) %s as %s", WebServ, from, chan->ops, newitem->nick, showchanoplevel(newitem->uflags));
	sendToChanOps(getChanData(chan->name), "%s added op %s as %s", from, newitem->nick, showchanoplevel(newitem->uflags));
	addChanOp(chan, newitem);
}

void WdelopCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	RegChanList *chan;
	cAccessList *delop;
	int a, x;
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :You must specify a channel and the op to delete", WebServ, from);
		return;
	}
	
	chan = getRegChanData(args[1]);
	
	if(!chan) {
		sSend(":%s PRIVMSG %s :The channel is not registered", WebServ, from);
		return;
	}

        if((chan->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	if((x = atoi(args[2]))) {
		for(delop=chan->firstOp;delop;delop=delop->next) {
			if(delop->index == x)
			  break;
		}
	}
	else
		delop = getChanOpData(chan, args[2]);
	
	if(!delop) {
		sSend(":%s PRIVMSG %s :%s is not in the ops list for %s", WebServ, from, args[2], chan->name);
		return;
	}
	
	if (!strcasecmp(chan->founder,args[2]))
	{
		sSend(":%s PRIVMSG %s :%s is the channel founder, and may not be removed from the ops list for %s.", WebServ, from, chan->founder, chan->name);
		return;
	}

	a=getChanOp(chan, from);
	if(((delop->uflags >= MFOUNDER && FOUNDER > a) || (delop->uflags >= MSOP && MFOUNDER > a) || a < SOP) && (!isRoot(nick)) && strcasecmp(from,args[2])) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	sendToChanOps(getChanData(chan->name), "%s deleted op %s [%s]", from, delop->nick, showchanoplevel(delop->uflags));
	sSend(":%s PRIVMSG %s :Deleted op %s on %s", WebServ, from, delop->nick, chan->name);
	delChanOp(chan, delop);
}

void WlistopCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	
	RegChanList *tmpchan;
	int levelsearch=0, i=0, x=0;
	char namesearch[NICKLEN] = "\0";
	cAccessList *tmp;
	
	if(numargs == 1) {
		sSend(":%s PRIVMSG %s :You must specify a channel", WebServ, from);
		return;
	}
	
	if(numargs == 2) {
		levelsearch = 0;
		namesearch[0] = 0;
	}
	if(numargs == 3) {
		sSend(":%s PRIVMSG %s :Improper command format", WebServ, from);
		return;
	}
	if(numargs == 4) {
		if(!strcasecmp(args[2], "-l"))
		  levelsearch = atoi(args[3]);
		else if(!strcasecmp(args[2], "-n"))
		  strcpy(namesearch, args[3]);
		else {
			sSend(":%s PRIVMSG %s :Unknown search parameter", WebServ, from);
			return;
		}
	}

	tmpchan = getRegChanData(args[1]);
	
	if((tmpchan == NULL)) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1]);
		return;
	}

	if(!getChanOp(tmpchan, from) && !isOper(nick)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	sSend(":%s PRIVMSG %s :   Op Listing For %s", WebServ, from, tmpchan->name);
	sSend(":%s PRIVMSG %s :(Index) %-30s Level", WebServ, from, "Nick");
	for(tmp=tmpchan->firstOp;tmp;tmp=tmp->next,i++) {
		if(levelsearch) {
			if(tmp->uflags == levelsearch) {
                                sSend(":%s PRIVMSG %s :(%-3i) %-30s [%s]", WebServ, from, tmp->index, tmp->nick, showchanoplevel(tmp->uflags));
				x++;
			}
		}
		else if(namesearch[0]) {
			if(!match(tmp->nick, namesearch)) {
                                sSend(":%s PRIVMSG %s :(%-3i) %-30s [%s]", WebServ, from, tmp->index, tmp->nick, showchanoplevel(tmp->uflags));
				x++;
			}
		}
		else {
                        sSend(":%s PRIVMSG %s :(%-3i) %-30s [%s]", WebServ, from, tmp->index, tmp->nick, showchanoplevel(tmp->uflags));
			x++;
		}
	}
	sSend(":%s PRIVMSG %s :%i op elements searched", WebServ, from, i);
	sSend(":%s PRIVMSG %s :%i matched given conditions", WebServ, from, x);
}

void WchansetCmd(UserList *nick, char **args, int numargs) {
	char *from = nick->nick;
	RegChanList *chan;
	ChanList *tmp;
	
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :You must specify some form of argument after the SET command", WebServ, from);
		return;
	}
	
	chan = getRegChanData(args[1]);
	tmp = getChanData(args[1]);

	if(chan == NULL) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1]);
		return;
	}

     if((chan->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
      }
	
	if(MFOUNDER > getChanOp(chan, from) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}

	if(!strcasecmp(args[2], "PRIVATE")) {
		if(numargs>3) {
			if(!strcasecmp(args[3],"ON")) {
				chan->flags|=CPRIVATE;
				sSend(":%s PRIVMSG %s :Private mode is ON", WebServ, from);
				sendToChanOps(tmp,"%s set private mode on", from);
			}
			else if(!strcasecmp(args[3],"OFF")) {
				chan->flags&= ~CPRIVATE;
				sSend(":%s PRIVMSG %s :Private mode is OFF", WebServ, from);
				sendToChanOps(tmp,"%s set private mode off",from);
			}
		}
		else 
			sSend(":%s PRIVMSG %s :Private mode is %s", WebServ, from, (chan->flags&CPRIVATE) ? "ON" : "OFF");
	}
	else if(!strcasecmp(args[2], "OPGUARD")) {
		if(numargs>3) {
			if(!strcasecmp(args[3], "ON")) {
				chan->flags |= COPGUARD;
				sSend(":%s PRIVMSG %s :Op guard is ON", WebServ, from);
				sendToChanOps(tmp, "%s set op guard on", from);
			}
			else if(!strcasecmp(args[3], "OFF")) {
				chan->flags &= ~COPGUARD;
				sSend(":%s PRIVMSG %s :Op guard is OFF", WebServ, from);
				sendToChanOps(tmp, "%s set op guard off", from);
			}
		}
		else 
			sSend(":%s PRIVMSG %s :Op guard is %s", WebServ, from, (chan->flags & COPGUARD) ? "ON" : "OFF");
	}
	else if(!strcasecmp(args[2], "KEEPTOPIC")) {
		if(numargs>3) {
			if(!strcasecmp(args[3], "ON")) {
				chan->flags |= CKTOPIC;
				sSend(":%s PRIVMSG %s :Topic holding is ON", WebServ, from);
				sendToChanOps(tmp, "%s set topic holding on", from);
			}
			else if(!strcasecmp(args[3], "OFF")) {
				chan->flags &= ~CKTOPIC;
				sSend(":%s PRIVMSG %s :Topic holding is OFF", WebServ, from);
				sendToChanOps(tmp, "%s set topic holding off", from);
			}
		}
		else
			sSend(":%s PRIVMSG %s :Topic holding is %s", WebServ, from, (chan->flags & CKTOPIC) ? "ON" : "OFF");
	}
	else if(!strcasecmp(args[2], "NAOP")) {
		if(numargs>3) {
			if(!strcasecmp(args[3], "ON")) {
				chan->flags |= CCLASSIC;
				sSend(":%s PRIVMSG %s :WebServ AutoOp on join is OFF", WebServ, from);
				sendToChanOps(tmp, "%s set WebServ AutoOp OFF", from);
			}
			else if(!strcasecmp(args[3], "OFF")) {
				chan->flags &= ~CCLASSIC;
				sSend(":%s PRIVMSG %s :WebServ AutoOp on join is ON", WebServ, from);
				sendToChanOps(tmp, "%s set WebServ AutoOp ON", from);
			}
		}
		else
			sSend(":%s PRIVMSG %s :WebServ AutoOp on join is %s", WebServ, from, (chan->flags & CCLASSIC) ? "OFF" : "ON");
	}

	else if(!strcasecmp(args[2], "IDENT")) {
		if(numargs>3) {
			if(!strcasecmp(args[3], "ON")) {
				chan->flags |= CIDENT;
				sSend(":%s PRIVMSG %s :Identification requirement is ON", WebServ, from);
				sendToChanOps(tmp, "%s set ID requirement on", from);
			}
			else if(!strcasecmp(args[3], "OFF")) {
				chan->flags &= ~CIDENT;
				sSend(":%s PRIVMSG %s :Identification requirement is OFF", WebServ, from);
				sendToChanOps(tmp, "%s set ID requirement off", from);
			}
		}
		else
			sSend(":%s PRIVMSG %s :Identification requirement is %s", WebServ, from, (chan->flags & CIDENT) ? "ON" : "OFF");
	}
	else if(!strcasecmp(args[2], "PROTOP")) {
		if(numargs>3) {
			if(!strcasecmp(args[3], "ON")) {
				chan->flags |= CPROTOP;
				sSend(":%s PRIVMSG %s :Op Protection is ON", WebServ, from);
				sendToChanOps(tmp, "%s set Op protection on", from);
			}
			else if(!strcasecmp(args[3], "OFF")) {
				chan->flags &= ~CPROTOP;
				sSend(":%s PRIVMSG %s :Op Protection is OFF", WebServ, from);
				sendToChanOps(tmp, "%s set op protection off", from);
			}
		}
		else
			sSend(":%s PRIVMSG %s :Op Protection is %s", WebServ, from, (chan->flags & CPROTOP) ? "ON" : "OFF");
	}
	else if(!strcasecmp(args[2], "QUIET")) {
		if(numargs>3) {
			if(!strcasecmp(args[3], "ON")) {
				sSend(":%s PRIVMSG %s :Quiet Changes mode is ON", WebServ, from);
				sendToChanOps(tmp, "%s set Quiet changes mode on, this is the last you'll hear from me", from);
				chan->flags |= CQUIET;
			}
			else if(!strcasecmp(args[3], "OFF")) {
				chan->flags &= ~CQUIET;
				sSend(":%s PRIVMSG %s :Quiet Changes mode is OFF", WebServ, from);
				sendToChanOps(tmp, "%s set quiet changes mode off", from);
			}
		}
		else
			sSend(":%s PRIVMSG %s :Quiet changes are %s", WebServ, from, (chan->flags & CQUIET) ? "ON" : "OFF");
	}
	else if(!strcasecmp(args[2],"FOUNDER"))
      	WfounderCmd(nick, args, numargs);
	else if(!match(args[2], "desc*")) {
		int i;
		chan->desc[0] = 0;
		if(numargs >= 4) {
			if(strlen(args[3]) <= 99) {
				strcpy(chan->desc, args[3]);
				for(i=4;i<numargs && strlen(chan->desc) + strlen(args[i]) <= 99;i++) {
					strcat(chan->desc, " ");
					strcat(chan->desc, args[i]);
				}
			}
		}
		if (chan->desc[0])
			sSend(":%s PRIVMSG %s :The description of %s is: %s", WebServ, from, chan->name, chan->desc);
		else
			sSend(":%s PRIVMSG %s :Description of %s cleared.", WebServ, from, chan->name);
	}
	else if(!strcasecmp(args[2], "NOTICE")) {
		if(numargs>3) {
			if(!strcasecmp(args[3], "ON")) {
				sSend(":%s PRIVMSG %s :Notice On Join is ON", WebServ, from);
				sendToChanOps(tmp, "%s set Notice On Join mode ON", from);
				chan->flags |= CNOTICE;
			}
			else if(!strcasecmp(args[3], "OFF")) {
				chan->flags &= ~CNOTICE;
				sSend(":%s PRIVMSG %s :Notice on Join is OFF", WebServ, from);
				sendToChanOps(tmp, "%s set Notice On Join mode off", from);
			}
		}
		else
			sSend(":%s PRIVMSG %s :Notice on Join is %s", WebServ, from, (chan->flags & CQUIET) ? "ON" : "OFF");
	}
	else
		sSend(":%s PRIVMSG %s :Unknown SET item", WebServ, from);
}

void WfounderCmd(UserList *nick, char **args, int numargs)
{
      char *from = nick->nick;
	cAccessList *newitem;
	RegChanList *chan;
	RegNickList *add;
	int founder_control;

	if(numargs<4) {
		sSend(":%s PRIVMSG %s :You must specify a channel and new nick", WebServ, from);
		return;
      }

	chan = getRegChanData(args[1]);

	if(!chan) {
		sSend(":%s PRIVMSG %s :%s channel is not registered", WebServ, args[1], from);
		return;
	}

        if((chan->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }

	founder_control = isFounder(chan,nick);

	if(!founder_control) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}

	add = getRegNickData(args[3]);
	if (!add || !(add->flags & NACTIVE))
	{
		sSend(":%s PRIVMSG %s :The nickname %s is not registered.  Nicknames must be registered to be channel founders.",WebServ,from,args[3]);
		return;
	}

	add->chans = countRegChans(add->nick);

	if ((add->chans >= ChanLimit) && (founder_control !=2))
	{
		sSend(":%s PRIVMSG %s :%s already has too many registered channels.", WebServ, from, add->nick);
		return;
	}

	newitem = getChanOpData(chan, add->nick);

	if (!newitem)
	{
		newitem = smalloc(sizeof(cAccessList));
		strcpy(newitem->nick, add->nick);
		addChanOp(chan, newitem);
	}

	newitem->uflags = FOUNDER;

	strcpy(chan->founder,newitem->nick);

	sSend(":%s PRIVMSG %s :Founder status of %s transferred to %s.", WebServ,from,chan->name,newitem->nick);
	sendToChanOps(getChanData(chan->name),"%s transferred founder status to %s.",from,newitem->nick);
	logDump(chanlog, "%s!%s@%s TRANSFER (%s) TO %s", nick->nick, nick->user, nick->host, chan->name, newitem->nick);
	add->chans++;

	if (founder_control !=2)
		nick->reg->chans--;
}

void WsetCmd(UserList *tmp, char **args, int numargs) {

	char *from = tmp->nick;
	
	if(numargs<2) {
		sSend(ERROR_BADUSE_WEBTV, WebServ, from);
		return;
	}

	if(tmp->caccess < 3) {
		sSend(":%s PRIVMSG %s :Access denied.", WebServ, from);
		return;
	}
	
	if(!strcasecmp(args[1], "kill")) {
		if(numargs<3) 
				sSend(":%s PRIVMSG %s :Your nick kill is currently %s", WebServ, from, (tmp->reg->flags & NKILL) ? "on" : "off"); 
		else {
			if(!strcasecmp(args[2], "on")) {
				tmp->reg->flags |= NKILL;
				sSend(":%s PRIVMSG %s :Your nick kill enforcement is now ON", WebServ, from);
			}
		  	else if(!strcasecmp(args[2], "off")) {
				tmp->reg->flags &= ~NKILL;
				sSend(":%s PRIVMSG %s :Your nick kill enforcement is now OFF", WebServ, from);
			}
		  	else
				sSend(":%s PRIVMSG %s :Unknown setting", WebServ, from);
		}
	}
	else if(!match(args[1], "passw*d")) {
		if(numargs<3)
			sSend(":%s PRIVMSG %s :You must specify a parameter", WebServ, from);
		else {
			if((4>strlen(args[2])) || (15<strlen(args[2])))
				sSend(":%s PRIVMSG %s :Please specify a password of 15 or less characters", WebServ, from);
			else {
				strncpy(tmp->reg->password, args[2], 15);
				sSend(":%s PRIVMSG %s :Your password is now \002%s\002, do not forget it! We are not responsible for lost passwords", WebServ, from, tmp->reg->password);
				tmp->reg->lastpwchange = CTime;
			}
		}
	}
	else if(!strcasecmp(args[1], "url")) {
		bzero(tmp->reg->url, 128);
		if(numargs<3)
			sSend(":%s PRIVMSG %s :Your URL has been cleared", WebServ, from);
		else {
			strncpy(tmp->reg->url, args[2], 127);
			sSend(":%s PRIVMSG %s :Your URL is now: \002%s\002", WebServ, from, tmp->reg->url);
		}
	}

	else if(!strcasecmp(args[1], "email")) {
		if(numargs<3)
			sSend(":%s PRIVMSG %s :Your email address is currently \002%s\002", WebServ, from, (tmp->reg->flags & NEMAIL) ? "public" : "private");
		else {
			if (!strcasecmp(args[2], "on") || !strcasecmp(args[2], "public")) {
				tmp->reg->flags |= NEMAIL;
				sSend(":%s PRIVMSG %s :Your email address is now \002public\002", WebServ, from);
			}
			else if(!strcasecmp(args[2], "off") || !strcasecmp(args[2], "private")) {
				tmp->reg->flags &= ~NEMAIL;
				sSend(":%s PRIVMSG %s :Your email address is now \002private\002", WebServ, from);
			}
			else
				sSend(":%s PRIVMSG %s :Unknown setting", WebServ, from);
		}
	}

	else if(!strcasecmp(args[1], "address")) {
		char sendfrom[80];
		int err;

		if(numargs<3) 
			sSend(":%s PRIVMSG %s :You must specify an e-mail address", WebServ, from);
		else {
			srandom(time(NULL));

			if((!strchr(args[2], '@')) || (strlen(args[2])<5) || (strlen(args[2])>EMAILLEN)) {
				sSend(":%s PRIVMSG %s :Please specify a valid e-mail address in the form of user@host", WebServ, from);
				return;
			}
		  
			if (countRegAddy(args[2]) >= NickLimit) {
				sSend(":%s PRIVMSG %s :You can register no more nick to that e-mail address.", WebServ, from);
				return;
			}

			sprintf(tmp->reg->password2, "%lu", (long) random());
			strcpy(tmp->reg->email, args[2]);
			sprintf(sendfrom, "Nickname services <%s@%s>", WebServ, NETWORK);
			err = sendMail(args[2], sendfrom, "Nickname activation key", 
				"\nYour nickname registration has been verified\n"
				"To activate your nickname: switch to the nickname %s and\n"
				"/msg %s ACTIVATE %s\n"
				"%s is your activation key\n"
				"Even when your nickname is registered, Do not lose this PLEASE.", 
				tmp->nick, WebServ, tmp->reg->password2, tmp->reg->password2);
			if(!err) {
				sSend(":%s PRIVMSG %s :Your nick has been temporarily de-activated to verify your new address", WebServ, from);
				sSend(":%s PRIVMSG %s :To re-activate please follow the same procedure as when you registered", WebServ, from);
				sSend(":%s PRIVMSG %s :All your previous data will be saved", WebServ, from);
				sSend(":%s PRIVMSG %s :Registration key sent to %s", WebServ, from, args[2]);
				tmp->reg->flags &= ~NACTIVE;
				tmp->reg->flags |= NDEACC;
			}
			else 
				sSend(":%s PRIVMSG %s :Mail could not be sent to specified address", WebServ, from);
		}
	}
	else if(!strcasecmp(args[1], "info")) {
		bzero(tmp->reg->info,200);
		if (numargs < 3)
			sSend(":%s PRIVMSG %s :Your nick info has been cleared.", WebServ, from);
		else {
			int pnt1;
			strncpy(tmp->reg->info, args[2], 200);
			for (pnt1 = 3; pnt1 < numargs; pnt1++)
			{
				if ((strlen(tmp->reg->info) + strlen(args[pnt1])) > 198)
					break;
				strcat(tmp->reg->info, " ");
				strcat(tmp->reg->info, args[pnt1]);
			}
			sSend(":%s PRIVMSG %s :Your nick info is now: \"%s\"", WebServ, from, tmp->reg->info);
		}
	}
	else if (!strcasecmp(args[1],"roleplay")) {
		if (!tmp->reg->flags2 & NROLEPLAY)
			sSend(":%s PRIVMSG %s :You do not have access to ROLEPLAY mode.", WebServ, from);
		else {
			HostClone *hc;
			UserClone *uc = NULL;
			hc = getCloneData(tmp->host);
			if (hc) {
				uc = getUserCloneData(hc,tmp->user);
				if (uc) {
					if (numargs < 3)
						sSend(":%s PRIVMSG %s :Roleplay mode is currently \002%s\002.", WebServ, from, (uc->roleplay == 1) ? "ON" : "OFF");
					else {
						if (!strcasecmp(args[2],"on")) {
							uc->roleplay = 1;
							sSend(":%s PRIVMSG %s :Roleplay mode is now \002ON\002.", WebServ, from);
						}
						else if (!strcasecmp(args[2],"off")) {
							uc->roleplay = 0;
							sSend(":%s PRIVMSG %s :Roleplay mode is now \002OFF\002.", WebServ, from);
						}
						else 
							sSend(":%s PRIVMSG %s :Unknown SET ROLEPLAY option \002%s\002.", WebServ, from, args[2]);
					}
				}
			}
			if (!uc)
				sSend(":%s PRIVMSG %s :You're a bot -- unable to set ROLEPLAY options.", WebServ, from);
		}
	}
	else if(!strcasecmp(args[1],"passwarn")) {
		if (numargs < 3)
			sSend(":%s PRIVMSG %s :Password warnings are currently \002%s\002.", WebServ, from, (tmp->reg->flags2&NNOPWWARN) ? "OFF" : "ON");
		else {
			if (!strcasecmp(args[2],"on")) {
				tmp->reg->flags2 &= ~NNOPWWARN;
				sSend(":%s PRIVMSG %s :Password warnings are now \002ON\002.", WebServ, from);
			}
			else if (!strcasecmp(args[2],"off")) {
				tmp->reg->flags2 |= NNOPWWARN;
				sSend(":%s PRIVMSG %s :Password warnings are now \002OFF\002.", WebServ, from);
			}
			else
				sSend(":%s PRIVMSG %s :Unknown setting", WebServ, from);
		}
	}
	else
		sSend(":%s PRIVMSG %s :Unknown set command %s, please try /msg %s HELP SET", WebServ, from, args[1], WebServ);
}

void WchanmodeCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	int a;
	RegChanList *tmp;
	ChanList *chan;
	
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :You must specify a channel and a mode.", WebServ, from);
		return;
	}
	
	tmp = getRegChanData(args[1]);
	chan = getChanData(args[1]);

	if(!chan) {
		sSend(":%s PRIVMSG %s :No such channel.", WebServ, from);
		return;
	}
	if(!tmp) {
		sSend(":%s PRIVMSG %s :%s is not registered.", WebServ, from, args[1]);
		return;
	}

        if((tmp->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	a = getChanOp(tmp, from);
	
	if(!a || !getChanOp(tmp, from)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	if(a < AOP) {
                sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	else {
            if(!strcasecmp(args[2], "INVITE")) {
		    sSend(":%s MODE %s +i", WebServ, args[1]);
                    sSend(":%s PRIVMSG %s :%s sets %s INVITE-ONLY.", WebServ, args[1], from, args[1]);
	            doRegChanMode(tmp);
            }
            else if(!strcasecmp(args[2], "SECRET")) {
                sSend(":%s PRIVMSG %s :%s sets %s SECRET.", WebServ, args[1], from, args[1]);
                sSend(":%s MODE %s +s", WebServ, args[1]);
		doRegChanMode(tmp);
            }
            else if(!strcasecmp(args[2], "PRIVATE")) {
                sSend(":%s PRIVMSG %s :%s sets %s PRIVATE.", WebServ, args[1], from, args[1]);
                sSend(":%s MODE %s +p", WebServ, args[1]);
		doRegChanMode(tmp);
            }
            else if(!strcasecmp(args[2], "OFF")) {
		if((tmp->flags & CFORCES)) {
			sSend(":%s PRIVMSG %s :Access denied.", WebServ, from);
			return;
		}
                sSend(":%s PRIVMSG %s :%s sets %s free of modes.", WebServ, args[1], from, args[1]);
                sSend(":%s MODE %s -sip", WebServ, args[1]);
		doRegChanMode(tmp);
            }
            else {
                sSend(":%s PRIVMSG %s :Unknown chanmode", WebServ, from);
            }
		return;
	}
}

void WaddakCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	cAkickList *newitem;
	RegChanList *chan;
	int i;
	
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :You must specify both a channel to add to, and a mask for ADDAK", WebServ, from);
		return;
	}
	
	chan = getRegChanData(args[1]);
	if(!chan) {
		sSend(":%s PRIVMSG %s :The channel must be registered to allow addition/removal of akicks", WebServ, from);
		return;
	}

        if((chan->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	if((MSOP > getChanOp(chan, from)) && (!isServop(nick))) {
		sSend(":%s PRIVMSG %s :Your access is too low to add akicks", WebServ, from);
		return;
	}
	
	if(chan->ops >= AkickLimit) {
		sSend(":%s PRIVMSG %s :%s has too many akicks", WebServ, from, chan->name);
		return;
	}
	newitem = getChanAkick(chan, args[2]);
	if(newitem) {
		sSend(":%s PRIVMSG %s :%s is already in the akick list", WebServ, from, args[2]);
		return;
	}

	if(!check_mask(args[2],isServop(nick))) {
		sSend(":%s PRIVMSG %s :Invalid AKick mask %s", WebServ, from, args[2]);
		return;
	}
	
	newitem = smalloc(sizeof(cAkickList));
	strcpy(newitem->mask, args[2]);
	sprintf(newitem->reason, "%s:", from);
	for(i=3;i<numargs && (strlen(newitem->reason) + strlen(args[i]) <= NICKLEN+51);i++) {
		strcat(newitem->reason, " ");
		strcat(newitem->reason, args[i]);
	}
	newitem->added = CTime;
	addChanAkick(chan, newitem);
	sendToChanOps(getChanData(chan->name), "%s added akick %s (%s)", from, newitem->mask, newitem->reason);
	sSend(":%s PRIVMSG %s :Added Akick %s to %s", WebServ, from, newitem->mask, chan->name);
}

void WdelakCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	RegChanList *chan;
	cAkickList *delak;
	int x;
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :You must specify a channel and the AKick to delete", WebServ, from);
		return;
	}
	
	chan = getRegChanData(args[1]);
	
	if(!chan) {
		sSend(":%s PRIVMSG %s :The channel is not registered", WebServ, from);
		return;
	}

        if((chan->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }

	if((x = atoi(args[2]))) {
		for(delak=chan->firstAkick;delak;delak=delak->next) {
			if(delak->index == x)
			  break;
		}
	}
	else
		delak = getChanAkick(chan, args[2]);
	
	if(!delak) {
		sSend(":%s PRIVMSG %s :%s is not in the akick list for %s", WebServ, from, args[2], chan->name);
		return;
	}
	
	if((MSOP > getChanOp(chan, from)) && (!isServop(nick))) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	sendToChanOps(getChanData(chan->name), "%s deleted akick %s", from, delak->mask);
	sSend(":%s PRIVMSG %s :Removed AKick %s on %s", WebServ, from, delak->mask, chan->name);
	delChanAkick(chan, delak);
}

void WlistakCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	char aktime[30];
	RegChanList *tmpchan;
	int i=0, x=0;
	char namesearch[NICKLEN+USERLEN+HOSTLEN] = "\0";
	cAkickList *tmp;
	
	if(numargs == 1) {
		sSend(":%s PRIVMSG %s :You must specify a channel", WebServ, from);
		return;
	}
	
	if(numargs == 2) {
		namesearch[0] = 0;
	}
	if(numargs == 3) {
		sSend(":%s PRIVMSG %s :Improper command format", WebServ, from);
		return;
	}
	if(numargs == 4) {
		if(!strcasecmp(args[2], "-n"))
		  strcpy(namesearch, args[3]);
		else {
			sSend(":%s PRIVMSG %s :Unknown search parameter", WebServ, from);
			return;
		}
	}
	
	tmpchan = getRegChanData(args[1]);
	
	if(!tmpchan) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1]);
		return;
	}
	
	if(!getChanOp(tmpchan, from) && !isOper(nick)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	sSend(":%s PRIVMSG %s :Akick Listing For %s", WebServ, from, args[1]);
	sSend(":%s PRIVMSG %s :(Index) (Mask)", WebServ, from);
	sSend(":%s PRIVMSG %s :(Time [GMT])     (Reason)", WebServ, from);
	for(tmp=tmpchan->firstAkick;tmp;tmp=tmp->next,i++) {
		if(namesearch[0]) {
			if(!match(tmp->mask, namesearch)) {
				strftime(aktime, 15, "%a %d/%m/%Y %T", gmtime(&tmp->added));
				sSend(":%s PRIVMSG %s :(%-3i) (%-s)", WebServ, from, tmp->index, tmp->mask);
				sSend(":%s PRIVMSG %s :(%20-s) (%-s)", WebServ, from, aktime, tmp->reason);
				x++;
			}
		}
		else {
			strftime(aktime, 15, "%a %d/%m/%Y %T", gmtime(&tmp->added));
			sSend(":%s PRIVMSG %s :(%-3i) (%-s)", WebServ, from, tmp->index, tmp->mask);
			sSend(":%s PRIVMSG %s :(%20-s) (%-s)", WebServ, from, aktime, tmp->reason);
			x++;
		}
	}
	sSend(":%s PRIVMSG %s :%i akick elements searched", WebServ, from, i);
	sSend(":%s PRIVMSG %s :%i matched given conditions", WebServ, from, x);
}

void WCaccessCmd(UserList *nick, char **args, int numargs)
{
	char *from = nick->nick;
	RegChanList *tmp;
	int test_level;

	if(numargs<2) {
		sSend(":%s PRIVMSG %s :You must specify at least a channel", WebServ, from);
		return;
	}
	
	tmp = getRegChanData(args[1]);
	
	if(!tmp) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1]);
		return;
	}

	if(numargs > 2)
	{
		test_level = getChanOp(tmp, args[2]);
		sSend(":%s PRIVMSG %s :%s has %s access on %s", WebServ, from, args[2], showchanoplevel(test_level), tmp->name);
	}
	else
	{
		test_level = getChanOp(tmp, from);
		sSend(":%s PRIVMSG %s :You have %s access on %s", WebServ, from, showchanoplevel(test_level), tmp->name);
	}
	return;
}

void WmodelockCmd(UserList *nick, char **args, int numargs) {
	int onargs = 3;
	int on=1;
	RegChanList *chan;
	ChanList *tmp;
	char *from = nick->nick;
	int i;
   	char mode[20];
        ChanList *c;

        if(!(c=getChanData(args[1]))) {
                sSend(":%s PRIVMSG %s :Access denied. You will have to be inside the channel.", WebServ, from);
                return;
        }
	
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :Too few arguments to MODELOCK command", WebServ, from);
		return;
	}
	
	chan = getRegChanData(args[1]);
	
	if(!chan) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1]);
		return;
	}
	
        if((chan->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }

	if((MFOUNDER > getChanOp(chan, from)) && (!isRoot(nick))) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	chan->mlock = 0;
	for(i=0;i<strlen(args[2]);i++) {
		switch(args[2][i]) {
		 case '+':
			on = 1;
			break;
		 case '-':
			on = 0;
			break;
		 case 'c':
			if(on) {
				chan->mlock |= PM_C;
				chan->mlock &= ~MM_C;
			}
			else {
				chan->mlock |= MM_C;
				chan->mlock &= ~PM_C;
			}
			break;
		 case 'i':
			if(on) {
				chan->mlock |= PM_I;
				chan->mlock &= ~MM_I;
			}
			else {
				chan->mlock |= MM_I;
				chan->mlock &= ~PM_I;
			}
			break;
		 case 'k':
			if(on) {
				if(numargs<(onargs+1))
				  sSend(":%s PRIVMSG %s :+k not set, no key specified", WebServ, from);
				else {
					strcpy(chan->key, args[onargs]);
					onargs++;
					chan->mlock |= PM_K;
					chan->mlock &= ~MM_K;
				}
			}
			else {
				chan->mlock |= MM_K;
				chan->mlock &= ~PM_K;
			}
			break;
		 case 'l':
			if(on) {
				if(numargs<(onargs+1))
				  sSend(":%s PRIVMSG %s :+l not set, no limit specified", WebServ, from);
				else {
					chan->limit = atoi(args[onargs]);
					onargs++;
					chan->mlock |= PM_L;
					chan->mlock &= ~MM_L;
				}
			}
			else {
				chan->mlock |= MM_L;
				chan->mlock &= ~PM_L;
			}
			break;
		 case 'm':
			if(on) {
				chan->mlock |= PM_M;
				chan->mlock &= ~MM_M;
			}
			else {
				chan->mlock |= MM_M;
				chan->mlock &= ~PM_M;
			}
			break;
		 case 'n':
			if(on) {
				chan->mlock |= PM_N;
				chan->mlock &= ~MM_N;
			}
			else {
				chan->mlock |= MM_N;
				chan->mlock &= ~PM_N;
			}
			break;
		 case 'p':
			if(on) {
				chan->mlock |= PM_P;
				chan->mlock &= ~MM_P;
			}
			else {
				chan->mlock |= MM_P;
				chan->mlock &= ~PM_P;
			}
			break;
		 case 's':
			if(on) {
				chan->mlock |= PM_S;
				chan->mlock &= ~MM_S;
			}
 
                        else {
    
			    tmp = getChanData(args[1]);               
                                
			    if ((isForced(tmp->name) || (tmp->reg && tmp->reg->flags&CFORCES)) && !(tmp->reg && tmp->reg->flags&CFEXEMPT))  {
				sSend(":%s PRIVMSG %s :Sorry you cannot set the -s mode due to a precaution to our younger users.", WebServ, from);
                                return;
			    }

		            else {
					chan->mlock |= MM_S;
					chan->mlock &= ~PM_S;
			     }	
			}
			break;
		 case 't':
			if(on) {
				chan->mlock |= PM_T;
				chan->mlock &= ~MM_T;
			}
			else {
				chan->mlock |= MM_T;
				chan->mlock &= ~PM_T;
			}
			break;
		}
	}
	
	makeModeLockStr(chan, mode);
	sendToChanOps(getChanData(chan->name), "%s set modelock (%s)", from, mode);
	doRegChanMode(chan);
	sSend(":%s PRIVMSG %s :Mode for %s is now locked to %s", WebServ, from, chan->name, mode);
}


void WrestrictCmd(UserList *nick, char **args, int numargs) {
	RegChanList *chan;
	char *from = nick->nick;
	int reslevel;
	
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :Too few arguments to RESTRICT command", WebServ, from);
		return;
	}
	
	chan = getRegChanData(args[1]);
	
	if(!chan) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1]);
		return;
	}

        if((chan->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }

	if((MFOUNDER > getChanOp(chan, from)) && (!isRoot(nick))) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	reslevel = atoi(args[2]);
	if((reslevel > getChanOp(chan, from)) && (!isRoot(nick))) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	chan->restrictlevel = reslevel;
	
	sendToChanOps(getChanData(chan->name), "%s has set restriction to %i+ levels", from, reslevel);
	sSend(":%s PRIVMSG %s :%s is now restricted to %i+ level users", WebServ, from, chan->name, reslevel);
}

void WtopiclockCmd(UserList *nick, char **args, int numargs) {
	RegChanList *chan;
	char *from = nick->nick;
	int reslevel;
	
	if(numargs<3) {
		sSend(":%s PRIVMSG %s :Too few arguments to TOPICLOCK command", WebServ, from);
		return;
	}
	
	chan = getRegChanData(args[1]);
	
	if(!chan) {
		sSend(":%s PRIVMSG %s :The channel must be registered", WebServ, from);
		return;
	}
	
	if((MFOUNDER > getChanOp(chan, from)) && (!isRoot(nick))) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	reslevel = atoi(args[2]);
	if((reslevel > getChanOp(chan, from)) && (!isRoot(nick))) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}
	
	chan->tlocklevel = reslevel;
	
	sendToChanOps(getChanData(chan->name), "%s has set topic restriction to %i+ levels", from, reslevel);
	sSend(":%s PRIVMSG %s :Topic change restriction for %s has been set to %i+ levels", WebServ, from, chan->name, reslevel);
}

void WCdropCmd(UserList *nick, char **args, int numargs)
{
	RegChanList *tmp;
	ChanList *chan;
	char *from = nick->nick;
        int oper_drop;
	
	if(numargs<2) {
		sSend(":%s PRIVMSG %s :You must specify a channel", WebServ, from);
		return;
	}
	
	tmp = getRegChanData(args[1]);
	if(!tmp) {
		sSend(":%s PRIVMSG %s :The channel is not registered", WebServ, from);
		return;
	}

        if((tmp->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	if(!isFounder(tmp, nick)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		return;
	}

        /* DON'T DECREMENT OPERS CHAN COUNT */
        oper_drop = 0;
        if (!match(tmp->founder,from))
           oper_drop = 1;

	sendToChanOps(getChanData(tmp->name), "%s just dropped %s", from, args[1]);
	sSend(":%s PRIVMSG %s :Channel registration for %s has been discontinued", WebServ, from, args[1]);
	chan = getChanData(args[1]);
	if(chan)
	  chan->reg = NULL;
	logDump(chanlog, "%s!%s@%s DROP (%s)", nick->nick, nick->user, nick->host, tmp->name);
	delRegChan(tmp);
       
        if (!oper_drop)
        {
           /* DON'T LET NICKSERV GO NEGATIVE */
           if (nick->reg->chans > 0)
	      nick->reg->chans--;
        }
        return;
}

void WinviteCmd(UserList *nick, char **args, int numargs) {
	char *from = nick->nick;
	RegChanList *chan;
	
	if(numargs<2) {
		sSend(":%s PRIVMSG %s :You must specify a channel.", WebServ, from);
		return;
	}
	
	chan = getRegChanData(args[1]);
	
	if(!chan) {
		sSend(":%s PRIVMSG %s :%s isn't registered", WebServ, from, args[1]);
		return;
	}

        if((chan->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
										  
	if((1 > getChanOp(chan, from)) && (!isOper(nick)))
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
	else 
		sSend(":%s INVITE %s :%s", WebServ, from, chan->name);
}

void WmassdeopCmd(UserList *nick, char **args, int numargs) {
	char *from = nick->nick;
	cNickList *x;
	ChanList *c;
	RegChanList *rc;
	int l,ml,w;
	
	char deoplist[512];
	char devclist[512];
	int dop,dvc;
	
	if(numargs<1) {
		sSend(":%s PRIVMSG %s :You must specify a channel",WebServ,from);
		return;
	}
	
	if(!(c=getChanData(args[1]))) {
		sSend(":%s PRIVMSG %s :%s does not exist", WebServ, from,args[1]);
		return;
	}
	if(!(rc=getRegChanData(args[1]))) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1]);
		return;
	}

        if((rc->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }
	
	l=getChanOp(rc,from);
	
	w=ml=0;
	for(x=c->firstUser;x;x=x->next) {
		w=getChanOp(rc,x->person->nick);
		if(w>ml) {
			ml=w;
		}
	}
	if((ml>l || !l) && !isOper(nick)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		sSend(":%s PRIVMSG %s :%s tried to massdeop, but failed.", WebServ, c->name, from);
		return;
	}
	else {
		bzero(deoplist,512);
		bzero(devclist,512);
		dop=dvc=0;
		for(x=c->firstUser;x;x=x->next) {
			if(dop==6) {
				sSend(":%s MODE %s -oooooo %s", WebServ, c->name,deoplist);
				sSend(":%s PRIVMSG %s :deop'd: %s", WebServ, from, deoplist);
				dop=0;
				bzero(deoplist,512);
			}
			if(dvc==6) {
				sSend(":%s MODE %s -vvvvvv %s", ChanServ, c->name,devclist);
				sSend(":%s PRIVMSG %s :devoice'd: %s", WebServ, from, devclist);
				dvc=0;
				bzero(devclist,512);
			}
			if(x->op&CHANOP) {
				dop++;
				strcat(deoplist, " ");
				strcat(deoplist, x->person->nick);
				x->op&= ~CHANOP;
			}
			else if(x->op&CHANVOICE) {
				dvc++;
				strcat(devclist," ");
				strcat(devclist,x->person->nick);
				x->op &= ~CHANVOICE;
			}
		}
		if(dop) {
			sSend(":%s MODE %s -oooooo %s", WebServ, c->name,deoplist);
			sSend(":%s PRIVMSG %s :deop'd: %s", WebServ, from, deoplist);
			dop=0;
			bzero(deoplist,512);
		}
		if(dvc) {
			sSend(":%s MODE %s -vvvvvv %s", WebServ, c->name,devclist);
			sSend(":%s PRIVMSG %s :devoice'd: %s", WebServ, from, devclist);
			dvc=0;
			bzero(devclist,512);
		}
	}
}


void WmasskickCmd(UserList *nick, char **args, int numargs) {
	char *from=nick->nick;
	cNickList *x, *nextnick = NULL;
	ChanList *c;
	RegChanList *rc;
	int ml,l,w;
	int kicked;
	
	if(numargs<1) {
		sSend(":%s PRIVMSG %s :You must specify a channel",WebServ, from);
		return;
	}
	
	if(!(c=getChanData(args[1]))) {
		sSend(":%s PRIVMSG %s :%s does not exist", WebServ, from, args[1]);
		return;
	}
	if(!(rc=getRegChanData(args[1]))) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1]);
		return;
	}
	
        if((rc->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }

	l=getChanOp(rc,from);
	
	w=ml=0;
	for(x=c->firstUser;x;x=x->next) {
		w=getChanOp(rc,x->person->nick);
		if(w>ml) {
			ml=w;
		}
	}
	if((ml>l || !l) && !isOper(nick)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		sendToChanOps(c, "%s tried to masskick, but failed.", from);
		return;
	}
	else {
		kicked=0;
		
		createGhostChannel(c->name);
		timer(10,deleteGhostChannel, "deleteGhostChannel", c->name);
		for(x=c->firstUser;x;x=nextnick) {

			nextnick = x->next;

			if(x->person != nick) {
				kicked++;
				sSend(":%s KICK %s %s :Masskick from \002%s\002", WebServ, c->name, x->person->nick, from);
				remUserFromChan(x->person,c->name);
			}
		}
		
		sSend(":%s PRIVMSG %s :%i people kicked.", WebServ, from, kicked);
		sSend(":%s PRIVMSG %s :Masskick complete, channel cleared.", WebServ, from);
	}
}

void WmodeclearCmd(UserList *nick, char **args, int numargs) {
	char *from=nick->nick;
	cNickList *x;
	ChanList *c;
	RegChanList *rc;
	int ml,l,w;
	
	if(numargs<1) {
		sSend(":%s PRIVMSG %s :You must specify a channel",WebServ,from);
		return;
	}
	
	if(!(c=getChanData(args[1]))) {
		sSend(":%s PRIVMSG %s :%s does not exist", WebServ, from,args[1]);
		return;
	}
	if(!(rc=getRegChanData(args[1]))) {
		sSend(":%s PRIVMSG %s :%s is not registered", WebServ, from, args[1]);
		return;
	}
	
        if((rc->flags & CFREEZE) && !isServop(nick)) {
		sSend(":%s PRIVMSG %s :Access denied. This channel is FROZEN.", WebServ, from);
		return;
        }

	l=getChanOp(rc,from);

	w=ml=0;
	for(x=c->firstUser;x;x=x->next) {
		w=getChanOp(rc,x->person->nick);
		if(w>ml) {
			ml=w;
		}
	}
	if((ml>l || !l) && !isOper(nick)) {
		sSend(":%s PRIVMSG %s :Access denied", WebServ, from);
		sSend(":%s PRIVMSG %s :%s tried to modeclear, but failed.", WebServ, c->name, from);
		return;
	}
	else {
		sSend(":%s MODE %s -iklmnpstc cowsRleet", WebServ, c->name);
		sSend(":%s PRIVMSG %s :Modeclear successful", WebServ, from);
	}
}

void WNaccessCmd(UserList *nick, char **args, int numargs)
{
	if(numargs<2)
     {
		  sSend(":%s PRIVMSG %s :Your access is %i", WebServ, nick->nick, nick->caccess);
		  return;
     }
   
   if(!strcasecmp(args[1], "list"))
     {
		  nAccessList *tmp;
		  if(numargs<3)
			 {
				 sSend(":%s PRIVMSG %s :Access list for %s:", WebServ, nick->nick, nick->nick);
				 for(tmp=nick->reg->firstAcc;tmp;tmp=tmp->next) {
					 sSend(":%s PRIVMSG %s :%2i:  %s", WebServ, nick->nick, tmp->index, tmp->mask);
				 }
				 sSend(":%s PRIVMSG %s :End of list for %s", WebServ, nick->nick, nick->nick);
			 }
     }
   else if(!strcasecmp(args[1], "add"))
     {
		  if(numargs<3)
			 {
				 sSend(":%s PRIVMSG %s :You must specify a mask to add", WebServ, nick->nick);
				 return;
			 }
		  
		  addAccessMask(args[2], nick);
		  return;
     }
   else if(!strncasecmp(args[1], "del", 3)) /* also accepts delete */
     {
		  if(numargs<3)
			 {
				 sSend(":%s PRIVMSG %s :You must specify a mask to delete", WebServ, nick->nick);
				 return;  
			 }
		  
		  delAccessMask(args[2], nick);
		  return;
	  }
	else {
		UserList *info;
		
		info = getNickData(args[1]);
		
		if(!info) {
			sSend(":%s PRIVMSG %s :%s is not online, access is \0020\002", WebServ, nick->nick, args[1]);
			return;
		}
		
		else {
			sSend(":%s PRIVMSG %s :Current access level for \002%s\002 is \002%i\002", WebServ, nick->nick, info->nick, info->caccess);
		}
	}
}

void WNdropCmd(UserList *tmp, char **args, int numargs) {
	
	char *from = tmp->nick;
      if(numargs<2) {
		sSend(":%s PRIVMSG %s :You must supply the password to drop your nick.", WebServ, from);       
		return;
	}

	if(!(tmp->reg)) {
		sSend(":%s PRIVMSG %s :Your nick is not registered.", WebServ, from);
		return;
	}

	if(!strncmp(args[1], tmp->reg->password, 15)) {
		mostnicks--;
		sSend(":%s PRIVMSG %s :Your nick %s has been dropped.", WebServ, from, from);
		logDump(nicklog, "%s!%s@%s: DROP\n", from, tmp->user, tmp->host);	
		delRegNick(tmp->reg);
		return;
	}
}

void WreleaseCmd(UserList *nick, char **args, int numargs) {
	
	char *from = nick->nick;
	RegNickList *tmp;
	
	if(numargs < 3) {
		sSend(":%s PRIVMSG %s :You must specify the nick and its password to RELEASE.", WebServ, from);
		return;
	}
	
	if(isGhost(args[1])) {
		tmp = getRegNickData(args[1]);
		if (!tmp) {
			sSend(":%s PRIVMSG %s :%s is not registered.", WebServ, from, args[1]);
		}
		else {
			if (!strcasecmp(args[2], tmp->password)) {
				delGhost(args[1]);
				sSend(":%s PRIVMSG %s :The nick %s has been released", WebServ, from, args[1]);				
			}
			else {
				sSend(":%s PRIVMSG %s :Access denied.", WebServ, from);
			}
		}
	}
	else {
		sSend(":%s PRIVMSG %s:%s is not being held.", WebServ, from, args[1]);
	}
}

void WghostCmd(UserList *nick, char **args, int numargs)
{
	RegNickList *tmp;
	char *from = nick->nick;
	char ghoststr[80];
	int found_ghost = 0;

	if(numargs<3) {
		  sSend(":%s PRIVMSG %s :You must specify a nick and its password to ghost it.", WebServ, nick->nick);
		  return;
	}
   
	if(!strcasecmp(nick->nick, args[1])) {
		sSend(":%s PRIVMSG %s :You cannot ghost yourself.", WebServ, from);
		return;
	}
	
	tmp = getRegNickData(args[1]);

	if (!tmp) {
		sSend(":%s PRIVMSG %s :%s is not registered.", WebServ, from, args[1]);
		return;
	}

	found_ghost = isGhost(args[1]);

	if ((!found_ghost) && (!getNickData(args[1]))) {
		sSend(":%s PRIVMSG %s :%s is not online or a %s ghost.", WebServ, from, args[1], WebServ);
		return;
	}

	if (strcasecmp(tmp->password, args[2])) {
		sSend(":%s PRIVMSG %s :Access Denied.", WebServ, from);
		return;
	}

	sSend(":%s PRIVMSG %s :%s has been Ghosted, have a nice day. :)", WebServ, nick->nick, args[1]);

	if (found_ghost) {
		delGhost(args[1]);
		return;
	}

	sprintf(ghoststr, "Ghost by: %s", from);
	killUser(services[1], getNickData(args[1]), ghoststr);
	remUser(args[1]);
}	
